clear
clf

load('nuno.mat','agdata')
%load ecb_main_50_3.mat
load /home/jakub/Matlab/Nuno/asymmetric/ecb_main_50_M2_733714.mat

eonia=agdata(:,13);
reporate = agdata(:,14);
margrate=agdata(:,5);


load ecb_data.mat
% data comes from this

global auctions aucgroupsize bootdraws pstep

auctions = 50;
aucgroupsize = 1; 
bootdraws = 200;
pstep=0.005;


cutoff=7;
markup = 3;
[margvalall]=margvaladjust(margvalall,data,cutoff,markup);

[allavgmarg,allavgmargstd,avgmarg,allavgmarg_unw,allavgmargstd_unw,avgmarg_unw]=avgmargval(margvalall,data);


aucv = [1:50];

bidsummary = [];

for i=1:length(aucv)
    auc=aucv(i);
    [estim,bidsteps,bidstepscum,pgrid,invbidfunc,span]=dataread(data,auc,1);

    %estim(:,5)=data(:,5);  %price bid
    %estim(:,7)=data(:,11); %cumul q-bid
    %estim(:,6)=data(:,4)./data(:,9); % q-bid
    %estim(:,3)=data(:,9);  %Q for sale
    %estim(:,2)=data(:,2);  %auction ID
    %estim(:,4)=data(:,7);  %Bidder
    %estim(:,8)=data(:,8);  %Country
    %estim(:,1)=data(:,3);  %Bidder   
    
    auc
    %pause;
    
    biddervec = unique(estim(:,1));
    nbidder = length(biddervec);
    
    
    margv_thisauc = [];
    
    
    for bi = 1:nbidder
        v_thisbi = margvalall{auc,1}(bi,:);
        
        bidderid=estim(bidstepscum(bi,1),1);
        
        %pause;
        
        qwt_v_thisbi = avgmarg{auc,1}(bi);
        thisbi_ind = find(estim(:,4)==bidderid);
        thisbi_pbid = estim(thisbi_ind,5);
        thisbi_qbid = estim(thisbi_ind,6);
        thisbi_country = mode(estim(thisbi_ind,8));
  
        maxq_thisbi = sum(thisbi_qbid);
        qwt_b_thisbi = (thisbi_pbid'*thisbi_qbid)/maxq_thisbi;
        
        bidsummary = [bidsummary; [auc,biddervec(bi),qwt_b_thisbi,qwt_v_thisbi,maxq_thisbi,thisbi_country, margrate(auc), reporate(auc), eonia(auc)]];
        
        % 1st column - auction
        % 2nd - bidder ID
        % 3rd q-weighted price bid
        % 4th q-weighted valuation
        % 5th max q desired
        % 6th bidder's country
                
        margv_thisauc = [margv_thisauc; v_thisbi(find(v_thisbi~=0))'];
        
        
    end
    
    %pause;
    
    
    plot_bidfn=1;
    
    if plot_bidfn==1

    qvec=estim(:,6);
    pvec = estim(:,5);
    
    sortv = sortrows([-margv_thisauc, qvec],1);
    sortp = sortrows([-pvec,qvec],1);
    
    sortv(:,1) = -sortv(:,1)./eonia(auc);
    sortp(:,1) = -sortp(:,1)./eonia(auc);
    sortv(:,2) = cumsum(sortv(:,2)); 
    sortp(:,2) = cumsum(sortp(:,2));
       
    
        % plot bid fn
        hold on;
        figure(1)
        if auc<32        
            % bids and values
            %plot(sortv(:,2),sortv(:,1),'r-',sortp(:,2),sortp(:,1),'b-')
            % bids only
            % plot(sortp(:,2),sortp(:,1),'b-')
            % values only 
            plot(sortv(:,2),sortv(:,1),'r-')
        else
            % bids and values
            %plot(sortv(:,2),sortv(:,1),'m-',sortp(:,2),sortp(:,1),'c-')
            % bids only 
            %plot(sortp(:,2),sortp(:,1),'c-')
            % values only 
            plot(sortv(:,2),sortv(:,1),'m-')

        end
        axis([0 2 0.97 1.15])
    
        %pause;
    
        legend('Marg val/EONIA', 'Bid/EONIA')
        xlabel('Quantity Share demanded')
        ylabel('Yield (Bid)/EONIA')
        title(['Bidding Behavior in auctions',num2str(auc)])

    end
end    
