function invbidboot=bootsample(invbidfunc)

global bidstepscum estim Group1 Group2 nbidfun oversample aucgroupsize auctions

%In each auctiongroup, we should have 'aucgroupsize'*N bids by bidders. Let's count the nonzero bids we observe
%for each group, then we will assign "zero" bids so that the total number
%of bids in the data is indeed 'aucgroupsize'*N (we need to include zero bids for
%resampling)
invbidboot=zeros(aucgroupsize*(size(Group1,2)+size(Group2,2)),nbidfun(1,2)); %This will include the zero bids.

auct=1;
participants=[0 0 0]; %1st col: AuctionID, 2nd Group1, 3rd Group2
partid=zeros(auctions,max([Group1 Group2])); %entry equals 1 if participating in auction (rows auctions, col bidders)
span=ones(aucgroupsize,2);
for i=1:size(estim,1)
    if estim(max(i-1,1),2)~=estim(i,2), span(auct,2)=i-1; auct=auct+1; span(auct,1)=i; end
    partid(auct,estim(i,4))=1;
end
span(aucgroupsize,2)=i;
for i=1:auct
    submitters=0;
    otherbidders=0;
    for j=1:max([Group1 Group2])
        if partid(i,j)==1 && any(j==Group1)
            submitters=submitters+1;
        end
        if partid(i,j)==1 && any(j==Group2)
            otherbidders=otherbidders+1;
        end
    end
    if isempty(Group2)==1
        participants(i,:)=[span(i,1) submitters 0];
    else
        participants(i,:)=[span(i,1) submitters otherbidders];
    end
end
% # of zero bids in current auctiongroup
submitterzero=aucgroupsize*size(Group1,2)-sum(participants(:,2));
otherbidderzero=aucgroupsize*size(Group2,2)-sum(participants(:,3));


    
if isempty(oversample)==1;
    redfact=1; %reduction factor for over-sampling non-zero bids
    redfactdealer=1;
else
    redfact=oversample; %default is oversample=1,ie no oversampling
    redfactdealer=max(oversample-0.2,1);
end
    
%Draw Group1's bids
for i=1:aucgroupsize*size(Group1,2) %Let's draw Group1 first
    if rand>(submitterzero/(aucgroupsize*redfactdealer*size(Group1,2))) %Draw a nonzero bid
        drawnbidder=0; %To initiate the following loop
        while all(drawnbidder~=Group1) %keep drawing until a bid from this group
            k=ceil(rand*nbidfun(1,1));
            if any(estim(bidstepscum(k,1),4)==Group1)
                drawnbidder=estim(bidstepscum(k,1),4);
                invbidboot(i,:)=invbidfunc(k,:);
            end
        end
    end
end

%Draw Group2's bids (if size(Group2,2)=0 this loop will do nothing)
if size(Group2,2)>0
    for i=1:aucgroupsize*size(Group2,2) %Let's draw Group2
        if rand>(otherbidderzero/(aucgroupsize*redfact*size(Group2,2))) %Draw a nonzero bid
            drawnbidder=0; %To initiate the following loop
            while all(drawnbidder~=Group2) %keep drawing until a bid from this group
                k=ceil(rand*nbidfun(1,1));
                if any(estim(bidstepscum(k,1),4)==Group2)
                    drawnbidder=estim(bidstepscum(k,1),4);
                    invbidboot(aucgroupsize*size(Group1,2)+i,:)=invbidfunc(k,:);
                end
            end
        end
    end
end