clear
load('mv_regression.mat','marg_all','signif','insignif','shade_all','insignif_shade','signif_shade','bids_coeff','bids_data')
load('nuno.mat','agdata')
load ecb_data.mat
load('bidderdata.mat')
auctions=size(agdata,1);  

% Check if "random" dummy would result in a similar correlation structure
% in the pre-august period
marg_all=marg_all(1:32,:); % use only pre-turmoil period
observations=sum(marg_all~=0);
normalized_mv=marg_all-repmat(agdata(1:32,13),1,size(marg_all,2)).*(marg_all~=0);
 
    time=1:1:auctions;
    dummy2=(time>16)';
    check_mv_signif=[];
    check_mv_insignif=[];
    for bidder=1:size(marg_all,2)
        if observations(1,bidder)>2 && max(dummy2(marg_all(:,bidder)~=0))~=min(dummy2(marg_all(:,bidder)~=0)) %regression only if at least two observations
           ols=regstats(marg_all(marg_all(:,bidder)~=0,bidder), dummy2(marg_all(:,bidder)~=0),'linear',{'yhat','beta','tstat','fstat'});
           ols_norm=regstats(normalized_mv(marg_all(:,bidder)~=0,bidder),dummy2(marg_all(:,bidder)~=0) ,'linear',{'yhat','beta','tstat','fstat'});
           if ols_norm.tstat.pval(2,1)<=0.05 % significant turmoil effect
               check_mv_signif(end+1,:)=[bidder observations(1,bidder) ols_norm.tstat.beta(2,1) ols_norm.tstat.pval(2,1)];
           else % insignificant turmoil effect
               check_mv_insignif(end+1,:)=[bidder observations(1,bidder) ols_norm.tstat.beta(2,1) ols_norm.tstat.pval(2,1)];
           end
        end
    end

%bidder-by-bidder regression:
check_bids_coeff=[];
bids_data=bids_data(bids_data(:,1)<=20070051,:);
bids_data(:,4)=bids_data(:,1)>=20070029;
for i=1:bids_data(end,2)
    if sum(bids_data(:,2)==i)>2
        if min(bids_data(bids_data(:,2)==i,1))<20070029 && max(bids_data(bids_data(:,2)==i,1))>=20070029
           temp=regstats((bids_data(bids_data(:,2)==i,3)-bids_data(bids_data(:,2)==i,5)), bids_data(bids_data(:,2)==i,[4]) ,'linear',{'beta','tstat'});
           check_bids_coeff=[check_bids_coeff; i temp.tstat.beta(2,1) temp.tstat.pval(2,1) ]  ;          
        end
    end
end
disp(['Fraction of bids significantly affected: ' num2str(sum(check_bids_coeff(:,3)<=0.05)/size(check_bids_coeff,1))])

% correlation btw trouble prediction based on bids and on values
trouble=[];
for i=1:bids_data(end,2)
    if sum(check_mv_signif(:,1)==i)>0
       trouble=[trouble ; i check_bids_coeff(check_bids_coeff(:,1)==i,3)<=0.05 1 ]; 
    end
    if sum(check_mv_insignif(:,1)==i)>0
       trouble=[trouble ; i check_bids_coeff(check_bids_coeff(:,1)==i,3)<=0.05 0 ]; 
    end
end
disp(['Correlation in trouble prediction: ' mat2str(corrcoef(trouble(:,2), trouble(:,3)))])
disp(['Predicted based on bids, but not on val: ' num2str(sum(trouble(:,2)==1 & trouble(:,3)==0,1))])
disp(['Fraction of all: ' num2str(sum(trouble(:,2)==1 & trouble(:,3)==0,1)/size(trouble,1))])
disp(['Fraction of predicted by both: ' num2str(sum(trouble(:,2)==1 & trouble(:,3)==0,1)/sum(trouble(:,2)==1 & trouble(:,3)==1,1))])
disp(['Predicted based on values, but not on bids: ' num2str(sum(trouble(:,2)==0 & trouble(:,3)==1,1))])
disp(['Predicted based on both: ' num2str(sum(trouble(:,2)==1 & trouble(:,3)==1,1))])
disp(['Predicted based on neither: ' num2str(sum(trouble(:,2)==0 & trouble(:,3)==0,1))])

