%function[] = country(mro)
% this function does country level analysis of bids & values
% Parameters: mro==1 if MRO auctions, LTROs otherwise


if mro==1
    load('mv_regression.mat','marg_all','signif','insignif','shade_all','insignif_shade','signif_shade','bids_coeff','bids_data')
    %load('mv_regression_M2_733714.mat','marg_all','signif','insignif','signif_shade','insignif_shade','shade_all','bids_coeff','bids_data')
    %load('mv_regression_M1_733714.mat','marg_all','signif','insignif','signif_shade','insignif_shade','shade_all','bids_coeff','bids_data')
    load('nuno.mat','agdata')
    load ecb_data.mat
    load('bidderdata.mat')   
    load('alpha.mat')
    turmoilcutoff=32;   
else
    if mro~=3
%     load('/home/jakub/Matlab/Nuno/ltro/data_ltro.mat')
%     load('/home/jakub/Matlab/Nuno/ecb_ltro_19_M2_733799.mat')
%     load('/home/jakub/Matlab/Nuno/ecb_ltro_19_M2_733797.mat')
    load('data_ltro.mat')
    %load('ecb_main_ltro_19_M1_733803.mat')
    load('/home/jakub/Matlab/Nuno/ecb_main_ltro_19_M2_733815.mat')
    turmoilcutoff=11;
    agdata=agdata_ltro;
    signif_ltro=signif;

    %normalizing by subtracting EONIA
    normalized_mv=marg_all-repmat(agdata(:,13),1,size(marg_all,2)).*(marg_all~=0);
    observations=sum(marg_all~=0);
    time=1:1:auctions;
    dummy=(time>turmoilcutoff)';
    signif=[];
    insignif=[];
    for bidder=1:size(marg_all,2)
        if observations(1,bidder)>2 && max(dummy(marg_all(:,bidder)~=0))~=min(dummy(marg_all(:,bidder)~=0)) %regression only if at least two observations
           ols=regstats(marg_all(marg_all(:,bidder)~=0,bidder), dummy(marg_all(:,bidder)~=0),'linear',{'yhat','beta','tstat','fstat'});
           ols_norm=regstats(normalized_mv(marg_all(:,bidder)~=0,bidder),dummy(marg_all(:,bidder)~=0) ,'linear',{'yhat','beta','tstat','fstat'});
           if ols_norm.tstat.pval(2,1)<=pvalue % significant turmoil effect
               signif(end+1,:)=[bidder observations(1,bidder) ols_norm.tstat.beta(2,1) ols_norm.tstat.pval(2,1)];
           else % insignificant turmoil effect
               insignif(end+1,:)=[bidder observations(1,bidder) ols_norm.tstat.beta(2,1) ols_norm.tstat.pval(2,1)];
           end
        end
    end
    else        
        load('ecb_main_mro_50_M3_733890.mat','marg_all','signif','insignif')
        %load('mv_regression_M2_733714.mat','marg_all','signif','insignif','signif_shade','insignif_shade','shade_all','bids_coeff','bids_data')
        %load('mv_regression_M1_733714.mat','marg_all','signif','insignif','signif_shade','insignif_shade','shade_all','bids_coeff','bids_data')
        load('nuno.mat','agdata')
        load ecb_data.mat
        load('bidderdata.mat')   
        load('alpha.mat')
        turmoilcutoff=32;   
    end
    
end
%agdata: 1st: auction ID 2nd: duration (days) 3rd: min bid q 4th: min bid rate 5th: clearing rate 
%6th: rationing coeff  7th: ex post supply 8th: q-weighted avg bid 9th: total demand
%10th: N 11th: min bid 12th: max bid 13th: EONIA 14th: EUREPO 15th: EURIBOR
%

auctions=size(agdata,1);

%create q-weighted bids_data with country ID
bids_data=[];
counter=1;
if mro==1
    data=data(data(:,2)~=20070053 & data(:,2)~=20070090 & data(:,2)~=20070096,:);
end
for i=2:size(data,1)
    if data(i-1,3)~=data(i,3), counter=1; else counter=counter+1; end
    if i<size(data,1)
        if data(i,3)~=data(i+1,3)
            temp=0;
            temp=data(i-counter+1:i,5)'*data(i-counter+1:i,6)/sum(data(i-counter+1:i,6));
            bids_data=[bids_data; data(i,2) data(i,3) temp 0 0 0 0 data(i,10) ]; % record auction, bidder, q-wgtd bid
        end
    else %I know it is the same bidder on the last line in data
        temp=data(i-counter+1:i,5)'*data(i-counter+1:i,6)/sum(data(i-counter+1:i,6));
        bids_data=[bids_data; data(i,2) data(i,3) temp 0 0 0 0 data(i,10)]; % record auction, bidder, q-wgtd bid
    end
end
%Sort by bidders:
bids_data=sortrows(bids_data,[2 1 3]);
bids_data(:,4)=bids_data(:,1)>agdata(turmoilcutoff,1); %turmoil dummy

% add interest rates:
for i=1:auctions
    bids_data(bids_data(:,1)==agdata(i,1),7)=agdata(i,13); %eonia rate
    bids_data(bids_data(:,1)==agdata(i,1),5)=agdata(i,15); %euribor rate
    bids_data(bids_data(:,1)==agdata(i,1),6)=agdata(i,14); %eurepo rate
end

% create bids_all matrix with the same structure as marg_all:
bids_all=zeros(size(marg_all));
for i=1:auctions
   for j=1:size(marg_all,2) 
       if isempty(find(bids_data(:,1)==agdata(i,1) & bids_data(:,2)==j))==0
            bids_all(i,j)=bids_data(find(bids_data(:,1)==agdata(i,1) & bids_data(:,2)==j),3);
       end          
   end
end

%create max_dem alloted matrices with the same structure as marg_all: typical element
%(i,j) is auction i, maximal demand (or q alloted) of bidder j.
max_dem=zeros(size(marg_all));
alloted=zeros(size(marg_all));
for auc=1:auctions
    for j=1:size(marg_all,2)
       if isempty(find(data(:,2)==agdata(auc,1) & data(:,3)==j))==0
           %sum marginal demands of bidder j in auction auc
           max_dem(auc,j)=sum(data(find(data(:,2)==agdata(auc,1) & data(:,3)==j),4));
           alloted(auc,j)=sum(data(find(data(:,2)==agdata(auc,1) & data(:,3)==j & data(:,5)>agdata(auc,5)+0.001),4));
           %adjust for rationing:
           if isempty(data(find(data(:,2)==agdata(auc,1) & data(:,3)==j & data(:,5)>agdata(auc,5)-0.001 &  data(:,5)<agdata(auc,5)+0.001),4))==0
            alloted(auc,j)=alloted(auc,j)+data(find(data(:,2)==agdata(auc,1) & data(:,3)==j & data(:,5)>agdata(auc,5)-0.001 &  data(:,5)<agdata(auc,5)+0.001),4)*agdata(auc,6)/100;
           end
       end         
    end
end

% create a matrix with bidder IDs and corresponding country IDs
bidderID=(1:size(marg_all,2))';
for i=1:size(bidderID,1)
   if isempty(find(data(:,3)==i,1,'first'))==0
       bidderID(i,2)=data(find(data(:,3)==i,1,'first'),10);
   else
       bidderID(i,2)=0;
   end
end

% we have 13 countries, hence we can run regressions by using second column
% of bidderID to select columns of bid_all or marg_all matrices that
% correspond to that country bidders only
alphavar=zeros(size(marg_all));
for auc=1:auctions
    for bidder=1:size(marg_all,2)
        if marg_all(auc,bidder)>0
           alphavar(auc,bidder)=(marg_all(auc,bidder)-agdata(auc,15))/(agdata(auc,14)-agdata(auc,15));           
        end
    end
end

%country codes - 8th column in bids_data and also 2nd col in bidderID

% 1     AT	Austria
% 2     BE	Belgium
% 3     DE	Germany
% 4     ES	Spain
% 5     FI	Finland
% 6     FR	France
% 7     GR	Greece
% 8     IE	Ireland
% 9     IT	Italy
% 10	LU	Luxemburg
% 11	NL	Netherlands
% 12	PT	Portugal
% 13	SI	Slovenia
for i=1:13
    country_codes{i,1}=i;
end
country_codes{1,2}='AT';
country_codes{2,2}='BE';
country_codes{3,2}='DE';
country_codes{4,2}='ES';
country_codes{5,2}='FI';
country_codes{6,2}='FR';
country_codes{7,2}='GR';
country_codes{8,2}='IE';
country_codes{9,2}='IT';
country_codes{10,2}='LU';
country_codes{11,2}='NL';
country_codes{12,2}='PT';
country_codes{13,2}='SI';
country_codes{1,3}='Austria';
country_codes{2,3}='Belgium';
country_codes{3,3}='Germany';
country_codes{4,3}='Spain';
country_codes{5,3}='Finland';
country_codes{6,3}='France';
country_codes{7,3}='Greece';
country_codes{8,3}='Ireland';
country_codes{9,3}='Italy';
country_codes{10,3}='Luxemburg';
country_codes{11,3}='Netherlands';
country_codes{12,3}='Portugal';
country_codes{13,3}='Slovenia';

%%% ADD BIDDER COVARIATES:
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Bidder-level data preparation %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
load('bidderdata.mat')
auctions=50;
% prepare  bidder-level covariates:
% find auction dates in MRR data:
ind_auc=[];
for i=1:auctions
    ind_auc=[ind_auc; find(date_auctions(i,1)==date_mrr)];
end
mrr_data=[mrr(1,:) ; mrr(ind_auc+1,:)];
% find auction dates in CuAc data:
ind_auc=[];
for i=1:auctions
    ind_auc=[ind_auc; find(date_auctions(i,1)==date_cuac)];
end
cuac_data=[cuac(1,:) ; cuac(ind_auc+1,:)];
% find auction dates in CDS data:
ind_auc=[];
for i=1:auctions
    ind_auc=[ind_auc; find(date_auctions(i,1)==date_cds)];
end
cds_data=[cds(1,:) ; cds(ind_auc+1,:)];
% find auction dates in Equity data:
ind_auc=[];
for i=1:auctions
    ind_auc=[ind_auc; find(date_equities(i,1)==date_equities)];
end
equities_data=[equities(1,:) ; equities(ind_auc+1,:)];

% find auction dates in Deficiency data:
ind_auc=[];
for i=1:auctions
    ind_auc=[ind_auc; find(date_auctions(i,1)==date_deficiency)];
end
deficiency_data=[deficiency(1,:) ; deficiency(ind_auc+1,:)];

if mro==1
    %load('/tmp/country_alpha.mat','alphavar_ltro','bidderID_ltro','country_codes','agdata_ltro','max_dem_ltro','alloted_ltro','signif_ltro')    
    %save('/tmp/country_alpha2.mat','signif','alphavar','bidderID','country_codes','agdata','cds_data','equities_data','deficiency_data','max_dem','alloted')
else
    if mro~=3
        bidderID_ltro=bidderID;
        alphavar_ltro=alphavar;
        max_dem_ltro=max_dem;
        alloted_ltro=alloted;
        signif_ltro=signif;
        particip_ltro=max_dem>0;
        load('/tmp/country_alpha2.mat','alphavar','bidderID','country_codes','agdata','max_dem','alloted','cds_data','equities_data','deficiency_data','signif')
        save('/tmp/country_alpha.mat','particip_ltro','signif','signif_ltro','alphavar','alphavar_ltro','bidderID','bidderID_ltro','country_codes','agdata_ltro','agdata','cds_data','equities_data','deficiency_data','max_dem','max_dem_ltro','alloted','alloted_ltro')
    else
        alphavar_M3=alphavar;
        load('/tmp/country_alpha.mat','signif','signif_ltro','alphavar','alphavar_ltro','bidderID','bidderID_ltro','country_codes','agdata_ltro','agdata','cds_data','equities_data','deficiency_data','max_dem','max_dem_ltro','alloted','alloted_ltro')
        save('/tmp/country_alpha3.mat','signif','signif_ltro','alphavar','alphavar_ltro','alphavar_M3','bidderID','bidderID_ltro','country_codes','agdata_ltro','agdata','cds_data','equities_data','deficiency_data','max_dem','max_dem_ltro','alloted','alloted_ltro')
    end
end

%save('/tmp/country_alpha.mat','signif','signif_ltro','alphavar','alphavar_ltro','bidderID','bidderID_ltro','country_codes','agdata_ltro','agdata','cds_data','equities_data','deficiency_data','max_dem','max_dem_ltro','alloted','alloted_ltro')
%save('/tmp/country_alpha2.mat','signif','alphavar','bidderID','country_codes','agdata','cds_data','equities_data','deficiency_data','max_dem','alloted')

for indcountry=1:max(bidderID(:,2))
    for auc=1:auctions
        temp=alphavar(auc,find(bidderID(:,2)==indcountry));
        alpha_country(auc,indcountry)=mean(temp(temp~=0));
        alpha_country_obs(auc,indcountry)=sum(temp~=0);
        alpha_country_sd(auc,indcountry)=std(temp(temp~=0));
    end
end
particip=max_dem>0;

for indcountry=1:max(bidderID(:,2))
    temp=alpha_country_sd(isnan(alpha_country_sd(1:turmoilcutoff,indcountry))==0 & alpha_country_sd(1:turmoilcutoff,indcountry)~=0,indcountry);
    temp3=isnan(alpha_country_sd(turmoilcutoff+1:auctions,indcountry))==0 & alpha_country_sd(turmoilcutoff+1:auctions,indcountry)~=0;
    temp2=alpha_country_sd(turmoilcutoff+1:auctions,indcountry);
    temp2=temp2(temp3);
    sd_pre_post(indcountry,:)=[mean(temp) mean(temp2)]; 
end
%save('/tmp/country_alpha3.mat','particip','particip_ltro','alpha_country','alpha_country_obs','signif','signif_ltro','alphavar','alphavar_ltro','alphavar_M3','bidderID','bidderID_ltro','country_codes','agdata_ltro','agdata','cds_data','equities_data','deficiency_data','max_dem','max_dem_ltro','alloted','alloted_ltro')

% for country=1:max(bidderID(:,2))
%     figure(1)
%     plot(alpha_country(:,country))
%     hold on    
% end
% % 
% % 
% for country=1:max(bidderID(:,2))
%     figure
%     plot(alpha_country(:,country))
%     hold on   
% end
