function [effi,effSE,grossuref,allocdummy]=efficiency(margvalall,data,adj)
% global bidsteps bidstepscum estim pgrid nbidfun bootdraws invbidfunc N invbiddrawn
global auctions aucgroupsize bootdraws pstep

N=auctions/aucgroupsize;

%This file evaluates efficiency using the estimated marginal values.
%%% IMPORTANT: each entry in 'margvalall' has to be rounded to nearest
%%% pstep in order for the routine to be able to figure out rationing
%%% correctly, otherwise efficient allocation won't sum to 1

if nargin<3
    adj=0;
end

effSE=zeros(N,aucgroupsize);
expeff=zeros(N,aucgroupsize);
effi=zeros(N,aucgroupsize);
%effdiff_bp=zeros(N,aucgroupsize);
%effdiff_bpSE=zeros(N,aucgroupsize);
effdiff_mean=zeros(N,aucgroupsize);
%bootdraws=size(margvalall,2);
rat=zeros(N,aucgroupsize);
ratmax=zeros(N,aucgroupsize);
%load('nuno.mat','agdata')


for auctiongroup=1:N
  
    % sort marginal values to make them weakly decreasing
    pmax=0;
    for boot=1:bootdraws
        if adj~=1
            for i=1:size(margvalall{auctiongroup,boot},1)
                temp=isnan(margvalall{auctiongroup,boot}(i,:))==1;
                margvalall{auctiongroup,boot}(i,temp)=0;
                margval_sorted{auctiongroup,boot}(i,:)=sort(margvalall{auctiongroup,boot}(i,:),'descend');
                %make it strictly decreasing
                for j=2:size(margvalall{auctiongroup,boot},2)
                    if margval_sorted{auctiongroup,boot}(i,j)>0
                        if margval_sorted{auctiongroup,boot}(i,j-1)==margval_sorted{auctiongroup,boot}(i,j)
                            margval_sorted{auctiongroup,boot}(i,j-1)=margval_sorted{auctiongroup,boot}(i,j-1)+pstep;
                        end
                    end
                end
            end
        else
            if boot==1
                margval_sorted=margvalall;
            end                           
        end
        if max(max(margval_sorted{auctiongroup,boot}))<20 %crazy values otherwise
            pmax=max(pmax,max(max(margval_sorted{auctiongroup,boot})));
        end
        
    end
    
    
%Now we need to figure out who won how much...

[estim,bidsteps,bidstepscum,pgrid,invbidfunc,spanauc,span]=dataread(data,auctiongroup,aucgroupsize,pmax); 
%[spanauc,pclearauc,noncomp]=span();
pgridsize=size(pgrid);
datasize=size(invbidfunc);

% This adjustment is now done in the main file using the `margvaladj.m` routine.
% for boot=1:bootdraws
%     %round marginal values to the nearest pstep
%     margvalall{auctiongroup,boot}=round(margvalall{auctiongroup,boot}/pstep)*pstep;
%     for bidder=1:datasize(1,1)
%         for step=1:bidsteps(bidder,1)
%            %First replace NaN entries in the margval matrix with the bid (``lower
%            %bound'' on marginal valuation)
%            if isnan(margvalall{auctiongroup,boot}(bidder,step))==1
%                if bidder>1
%                    margvalall{auctiongroup,boot}(bidder,step)=estim(bidstepscum(bidder-1,1)+step,5);
%                else
%                    margvalall{auctiongroup,boot}(bidder,step)=estim(step,5);
%                end
%            end  
%            % Now replace crazy values of marginal values in margval matrix with the bid (``lower
%            % bound'' on marginal valuation) +200*pstep (one percentage point
%            % if pstep is half a basis point)
%            if margvalall{auctiongroup,boot}(bidder,step)>=7
%                if bidder>1
%                    margvalall{auctiongroup,boot}(bidder,step)=estim(bidstepscum(bidder-1,1)+step,5)+200*pstep;
%                else
%                    margvalall{auctiongroup,boot}(bidder,step)=estim(step,5)+200*pstep;
%                end
%            end  
%         end
%         for step=1:bidsteps(bidder,1)  
%            %corrects all margval to be nonincreasing                       
%            if step<bidsteps(bidder,1)
%                if margvalall{auctiongroup,boot}(bidder,step+1)>margvalall{auctiongroup,boot}(bidder,step)
%                  margvalall{auctiongroup,boot}(bidder,step+1)=margvalall{auctiongroup,boot}(bidder,step); %This uses the previous value as upper bound
%                end
%            end
%         end
%     end
%     d=size(margvalall{auctiongroup,boot}); 
%     for i=1:d(1,1) %this just simplifies coding - makes marg value strictly decreasing by at least one unit of price per step     
%         for j=2:d(1,2)
%             if margvalall{auctiongroup,boot}(i,j)==margvalall{auctiongroup,boot}(i,j-1) && margvalall{auctiongroup,boot}(i,j)>0
%                 k=1;
%                 while margvalall{auctiongroup,boot}(i,min(j+k,d(1,2)))==margvalall{auctiongroup,boot}(i,j-1) && margvalall{auctiongroup,boot}(i,j)>0 && j+k<d(1,2), k=k+1; end
%                 for a=1:k
%                     margvalall{auctiongroup,boot}(i,j+a-1)=margvalall{auctiongroup,boot}(i,j+a-1)-a*pstep;
%                 end
%             end
%         end
%     end
%     clear i j d a
% end

for auction=1:aucgroupsize
    
%first find the market clearing price on the grid:
p=find(sum(invbidfunc(spanauc(auction,2):spanauc(auction,3),:))>=1,1,'last');
pclearauc=pgrid(1,p);

%determine AD above market clearing price (clear price + 1) +
%noncompetitive bid
if p+1<=size(invbidfunc,2)
    ADabove(auctiongroup,auction)=sum(invbidfunc(spanauc(auction,2):spanauc(auction,3),p+1));
else
    ADabove(auctiongroup,auction)=0;
end

%Now determine marginal AD at market clearing price
ADmarg(auctiongroup,auction)=sum(invbidfunc(spanauc(auction,2):spanauc(auction,3),p))-ADabove(auctiongroup,auction);

%Rationing coefficient
if ADmarg(auctiongroup,auction)>0 
    rat(auctiongroup,auction)=max((1-ADabove(auctiongroup,auction))/ADmarg(auctiongroup,auction),0);
else
    rat(auctiongroup,auction)=1;
end

%Now construct same matrix as margvalall, which instead of marginal
%valuations will have how much quantity that bidder got
alloc=zeros(size(margvalall{auctiongroup,1}));

if auction==1
   begin=1;
else
   begin=bidstepscum(spanauc(auction-1,3),1)+1;
end

bidder=spanauc(auction,2);
step=1;
for i=begin:bidstepscum(spanauc(auction,3),1) %Cycles through all bids submitted in an auction
    if estim(i,5)+pstep/1000>pclearauc && estim(i,5)-pstep/1000>pclearauc %let's give full requests to bids above market clearing price       
       if step==1
           alloc(bidder,step)=estim(i,7); 
           step=step+1;
       else
           alloc(bidder,step)=estim(i,7)-estim(i-1,7);
           step=step+1;
       end
    end
    if estim(i,5)+pstep/1000>pclearauc && estim(i,5)-pstep/1000<pclearauc %let's adjust rationed bidders
        if step==1
             alloc(bidder,step)=estim(i,7)*rat(auctiongroup,auction);
             step=step+1;
        else
            alloc(bidder,step)=(estim(i,7)-estim(i-1,7))*rat(auctiongroup,auction);
            step=step+1;
        end
    end
            
    if i==bidstepscum(bidder,1); %switch to next bidder
        bidder=bidder+1;  
        step=1;
    end
end

clear help

%Now let's compute the actual gross surplus from the current auction - for each
%marginal valuation matrix
for boot=1:bootdraws   
    %help=margvalall{auctiongroup,boot}(spanauc(auction,2):spanauc(auction,3),:).*alloc(spanauc(auction,2):spanauc(auction,3),:);
    help=margval_sorted{auctiongroup,boot}(spanauc(auction,2):spanauc(auction,3),:).*alloc(spanauc(auction,2):spanauc(auction,3),:);    
    help=sum(help(:,:));
    actgrossur{auctiongroup,boot}(auction,1)=sum(help(:,:)); % surplus per 1 percent of supply sold
end

%Now let us get the maximal achievable surplus if we were to allocate
%units efficiently - this might be different for each 'bootdraw'

for boot=1:bootdraws  %start cycling bootdraws
    
%Now let's do the truthful demands using upper envelope of marginal
%valuations
truthdemmax=zeros(size(invbidfunc));
datsize=size(estim);

%for i=1:size(margvalall{auctiongroup,1},1)
for i=1:size(margval_sorted{auctiongroup,1},1)
    step=1;
    if i==1
        beginstep=0;
    else
        beginstep=bidstepscum(i-1,1);
    end
    for m=pgridsize(1,2):-1:1
       %if margvalall{auctiongroup,boot}(i,step)+pstep/1000>=pgrid(1,m)
       if margval_sorted{auctiongroup,boot}(i,step)+pstep/1000>=pgrid(1,m)
           if step<bidsteps(i,1)
                truthdemmax(i,m)=estim(beginstep+step+1,7);
           else               
                truthdemmax(i,m)=estim(beginstep+step,7);              
           end
       end
       if beginstep+step<datsize(1,1)
           if estim(beginstep+step,4)==estim(beginstep+step+1,4)
               %if step<bidsteps(i,1) && margvalall{auctiongroup,boot}(i,step+1)+pstep/1000>=pgrid(1,max(m-1,1)), step=step+1; end 
               if step<bidsteps(i,1) && margval_sorted{auctiongroup,boot}(i,step+1)+pstep/1000>=pgrid(1,max(m-1,1)), step=step+1; end 
           else
               if m==1, break, end
           end
       end                   
    end
end


    
ADmax=sum(truthdemmax(spanauc(auction,2):spanauc(auction,3),:));

%first find the market clearing price on the grid:
p=find(ADmax(1,:)>=1,1,'last');
if isempty(p)==1 % no market clearing
    disp(['No clearing: ' num2str(auctiongroup) ' ' num2str(auction) ' ' num2str(boot)])
    p=1;
end
pclearmax=pgrid(1,p);

%determine AD above market clearing price (clear price + 1) +
%noncompetitive bid
if p+1<=size(truthdemmax,2)
    ADabovemax(auctiongroup,auction)=sum(truthdemmax(spanauc(auction,2):spanauc(auction,3),p+1));
else
    ADabovemax(auctiongroup,auction)=0;
end
%Now determine marginal AD at market clearing price
ADmargmax(auctiongroup,auction)=sum(truthdemmax(spanauc(auction,2):spanauc(auction,3),p))-ADabovemax(auctiongroup,auction);

%Rationing coefficient
if ADmargmax(auctiongroup,auction)>0
    ratmax(auctiongroup,auction)=(1-ADabovemax(auctiongroup,auction))/ADmargmax(auctiongroup,auction);
else
    ratmax(auctiongroup,auction)=1;
end
  
%Now construct same matrix as margvalall, which instead of marginal
%valuations will have how much quantity that bidder got in the efficient
%alloc
%alloceff=zeros(size(margvalall{auctiongroup,boot}));
alloceff=zeros(size(margval_sorted{auctiongroup,boot}));

bidder=spanauc(auction,2);
for i=bidder:spanauc(auction,3)
    for step=1:bidsteps(i,1)
        %if margvalall{auctiongroup,boot}(i,step)+pstep/1000>pclearmax && margvalall{auctiongroup,boot}(i,step)-pstep/1000>pclearmax
        if margval_sorted{auctiongroup,boot}(i,step)+pstep/1000>pclearmax && margval_sorted{auctiongroup,boot}(i,step)-pstep/1000>pclearmax
            if step==1 && step<bidsteps(i,1)
                if i>1, alloceff(i,step)=estim(bidstepscum(i-1,1)+step+1,7); else alloceff(i,step)=estim(step+1,7); end
            else
                if step<bidsteps(i,1) 
                    if i>1
                        alloceff(i,step)=estim(bidstepscum(i-1,1)+step+1,7)-estim(bidstepscum(i-1,1)+step,7);                    
                    else
                        alloceff(i,step)=estim(step+1,7)-estim(step,7);                    
                    end
                else 
                    if step==1
                        %this is the case of only one bidpoint which should be satisfied
                        if i>1
                            alloceff(i,step)=estim(bidstepscum(i-1,1)+step,7);
                        else
                            alloceff(i,step)=estim(step,7);
                        end
                    end
                end %if at the last step, he would obtain quantity at k-1st step.                
            end
        else
            %if margvalall{auctiongroup,boot}(i,step)+pstep/1000>pclearmax && margvalall{auctiongroup,boot}(i,step)-pstep/1000<pclearmax %let's adjust rationed bidders
            if margval_sorted{auctiongroup,boot}(i,step)+pstep/1000>pclearmax && margval_sorted{auctiongroup,boot}(i,step)-pstep/1000<pclearmax %let's adjust rationed bidders
                if i>1
                    if step==1 && step<bidsteps(i,1)
                         alloceff(i,step)=estim(bidstepscum(i-1,1)+step+1,7)*ratmax(auctiongroup,auction);                     
                    else
                        if step<bidsteps(i,1)
                            alloceff(i,step)=(estim(bidstepscum(i-1,1)+step+1,7)-estim(bidstepscum(i-1,1)+step,7))*ratmax(auctiongroup,auction);                      
                        end                
                        if step==1
                            alloceff(i,step)=estim(bidstepscum(i-1,1)+step,7)*ratmax(auctiongroup,auction);
                        end
                    end
                else %this is bidder 1
                    if step==1 && step<bidsteps(i,1)
                         alloceff(i,step)=estim(step+1,7)*ratmax(auctiongroup,auction);                     
                    else
                        if step<bidsteps(i,1)
                            alloceff(i,step)=(estim(step+1,7)-estim(step,7))*ratmax(auctiongroup,auction);                      
                        end                
                        if step==1
                            alloceff(i,step)=estim(step,7)*ratmax(auctiongroup,auction);
                        end
                    end                    
                end
            end
        end
    end
end
if boot==1
    disp(['Alloceff: ' num2str(sum(sum(alloceff))) ' Auctiongroup: ' num2str(auctiongroup) ' Boot: ' num2str(boot)])
end
% if boot==1 %just to verify allocation is summing to 1
%     disp(['Auctiongroup: ' num2str(auctiongroup) ' , ' num2str(sum(sum(alloceff)))])
% end
clear help

% Let's store a binary if a given step would have been siatisfied in an
% efficient auction
allocdummy{auctiongroup,boot}=alloceff>0;
%Now let's compute the efficient gross surplus for each
%marginal valuation matrix
%help=margvalall{auctiongroup,boot}(spanauc(auction,2):spanauc(auction,3),:).*alloceff(spanauc(auction,2):spanauc(auction,3),:);
help=margval_sorted{auctiongroup,boot}(spanauc(auction,2):spanauc(auction,3),:).*alloceff(spanauc(auction,2):spanauc(auction,3),:);
help=sum(help(isnan(help)==0));
grossuref{auctiongroup,boot}(auction,1)=help; %eff surplus per tbill sold
clear help
effic{auctiongroup,boot}(auction,1)=actgrossur{auctiongroup,boot}(auction,1)/grossuref{auctiongroup,boot}(auction,1);
if boot==1 && grossuref{auctiongroup,boot}(auction,1)<actgrossur{auctiongroup,boot}(auction,1)
   disp(['Problem: eff s < act s, auctiongroup: ' num2str(auctiongroup)])
end
end %ends boot


%now let's do standard errors for efficiency
for boot=1:bootdraws
    expeff(auctiongroup,auction)=expeff(auctiongroup,auction)+effic{auctiongroup,boot}(auction,1)/bootdraws;
    effdiff_mean(auctiongroup,auction)=effdiff_mean(auctiongroup,auction)+(grossuref{auctiongroup,boot}(auction,1)-actgrossur{auctiongroup,boot}(auction,1))/(bootdraws*sum(sum(alloc)));
end
for boot=1:bootdraws
    effSE(auctiongroup,auction)=effSE(auctiongroup,auction)+(effic{auctiongroup,boot}(auction,1)-expeff(auctiongroup,auction))^2;
    %effdiff_bpSE(auctiongroup,auction)=effdiff_bpSE(auctiongroup,auction)+((grossuref{auctiongroup,boot}(auction,1)-actgrossur{auctiongroup,boot}(auction,1))-effdiff_mean(auctiongroup,auction))^2;
end
effSE(auctiongroup,auction)=sqrt(effSE(auctiongroup,auction))/(bootdraws-1);
%effdiff_bpSE(auctiongroup,auction)=sqrt(effdiff_bpSE(auctiongroup,auction))/(bootdraws-1);

effi(auctiongroup,auction)=effic{auctiongroup,1}(auction,1); 
%effdiff_bp(auctiongroup,auction)=(grossuref{auctiongroup,1}(auction,1)-actgrossur{auctiongroup,1}(auction,1)); %difference in surplus in basis points
end %ends auction loop
end %ends auctiongroup loop

%help=sum(expeff(:,:));
%expefftotal=sum(help(:,:))/auctions;
