function[exputmin,exputmax,util]=exputil_da(bidder,margval,psort,bidsteps,bidstepscum,estim)

%global model 

%This function computes the expected utility from a DA of a 'bidder' with values
%'margval' and distribution of market clearing prices being 'psort' and his
%actual bid being in estim.

%Now let's get expected utility: using his bidfunction, distribution of market
%clearing price and estimated values for those quantities, we can obtain
%this

%First cut nonclearing cases (zero prices or huge adjustments by gov't
%(i.e., strange draws of resid supply))
draws=size(psort);
step=1;
bad=0;
adjust=0;
exputmin=0;
exputmax=0;
util=0;
for i=1:draws(1,1)
    if psort(i,1)==0
        bad=bad+1;
    end
%     if psort(i,1)==auctionminprice
%         adjust=adjust+1;
%     end
end
% if model==2
%     puseful=psort(ceil(3*adjust/4)+1:draws(1,1),1);
%     %puseful=psort(:,1);
% else
    puseful=psort(bad+1:draws(1,1),1);
%end

n=size(puseful);
margsize=size(margval);
estsize=size(estim);
margval(1,margsize(1,2)+1)=0;
%Let's go from the highest price to evaluate how much the bidder gets
%The only problem is if the market clearing price equals his bid, since in
%that case he will be rationed. With marginal valuation being a step
%function there, it will matter if it is the upper bound case!
for i=n(1,1):-1:1
    grosutmin=0;
    grosutmax=0;
    pay=0;
    %if puseful(i,1)<margval(1,step) & puseful(i,1)>margval(1,step+1)
    if bidder==1
        if bidsteps(bidder)>step, lowerp=estim(step+1,5); else lowerp=0; end %this will denote the price of next step
        if puseful(i,1)<=estim(step,5) && puseful(i,1)>lowerp %let's not deal with rationing yet - assume if price same as bid, he gets full request
            %First step:
            grosutmin=margval(1,1)*estim(1,7);
            grosutmax=margval(1,1)*estim(min(2,bidsteps(bidder,1)),7);
            pay=estim(1,5)*estim(1,7);
            if step>1
                for j=2:step
                        grosutmax=grosutmax+margval(1,j)*(estim(min(j+1,bidsteps(bidder,1)),7)-estim(j,7)); %sums up gross utility
                        grosutmin=grosutmin+margval(1,j)*(estim(j,7)-estim(j-1,7));
                        pay=pay+estim(j,5)*(estim(j,7)-estim(j-1,7));
                end
            end
            %if puseful(i,1)==estim(step,5)
            %    disp('rationing...')
            %end
        else
            if puseful(i,1)<lowerp
               step=step+1;               
               i=i+1; %return one step in the loop
            end
        end
    else
        if bidsteps(bidder)>step, lowerp=estim(min(bidstepscum(bidder-1,1)+step+1,estsize(1,1)),5); else lowerp=0; end %this will denote the price of next step
        if puseful(i,1)<=estim(bidstepscum(bidder-1,1)+step,5) && puseful(i,1)>lowerp %let's not deal with rationing yet
                grosutmin=margval(1,1)*estim(bidstepscum(bidder-1,1)+1,7);
                grosutmax=margval(1,1)*estim(bidstepscum(bidder-1,1)+min(2,bidsteps(bidder,1)),7);
                if margval(1,1)>0
                    pay=estim(bidstepscum(bidder-1,1)+step,5)*estim(bidstepscum(bidder-1,1)+step,7);                   
                else
                     pay=0;                     
                end
                    
            if step>1
                for j=2:step
                    grosutmax=grosutmax+margval(1,j)*(estim(bidstepscum(bidder-1,1)+min(j+1,bidsteps(bidder,1)),7)-estim(bidstepscum(bidder-1,1)+j,7));
                    grosutmin=grosutmin+margval(1,j)*(estim(bidstepscum(bidder-1,1)+j,7)-estim(bidstepscum(bidder-1,1)+j-1,7));
                    pay=pay+estim(bidstepscum(bidder-1,1)+j,5)*(estim(bidstepscum(bidder-1,1)+j,7)-estim(bidstepscum(bidder-1,1)+j-1,7));
                end
            end                
        else
                if puseful(i,1)<lowerp
                        step=step+1;
                        i=i+1;
                end
        end
    end
    exputmin=exputmin+(grosutmin-pay)/n(1,1);
    exputmax=exputmax+(grosutmax-pay)/n(1,1);
    util(i,1)=(grosutmin-pay);
    util(i,2)=(grosutmax-pay);
end
