function [bidaddress, frequentbidders, bidderfrequency]=findbidaddress(data,freqcutoff)

% Figure out which auctions and on which lines in `invbidfunc' and
% `margvalall' in those auctions a bidder identity participates

global auctions aucgroupsize mro

if nargin<2 
    if mro~=1 % analyzing LTROs (only 19 auctions)
        freqcutoff=14;
    else
        freqcutoff=40;
    end
end

[estim,bidsteps,bidstepscum]=dataread(data,0);
largestbidder=max(estim(:,4));

bidaddress=mat2cell(zeros(largestbidder,3),ones(1,largestbidder),3);
for auctiongroup=1:auctions/aucgroupsize
    [estim,bidsteps,bidstepscum]=dataread(data,auctiongroup,aucgroupsize);
    newbid=1;
    for i=1:size(estim,1)-1
        if estim(i,4)~=estim(i+1,4)
            if bidaddress{estim(i,4),1}(end,3)>0
                bidaddress{estim(i,4),1}(end+1,:)=[auctiongroup newbid bidaddress{estim(i,4),1}(end,3)+1];
            else
                bidaddress{estim(i,4),1}(end,:)=[auctiongroup newbid bidaddress{estim(i,4),1}(end,3)+1];
            end
            newbid=newbid+1;
        end
    end 
    % correct for the last bid!
    if bidaddress{estim(end,4),1}(end,3)>0
        bidaddress{estim(end,4),1}(end+1,:)=[auctiongroup newbid bidaddress{estim(end,4),1}(end,3)+1];
    else
        bidaddress{estim(end,4),1}(end,:)=[auctiongroup newbid bidaddress{estim(end,4),1}(end,3)+1];
    end
    newbid=newbid+1;
end
  


frequentbidders=[]; % participating in more than 40 auctions
bidderfrequency=[]; % number of auction paricipating in by bidder identity
for i=1:size(bidaddress,1)
    if bidaddress{i,1}(end,3)>0
        bidderfrequency(end+1,:)=[i size(bidaddress{i,1},1)];
    end
    if bidaddress{i,1}(end,3)>freqcutoff %with participation above freqcutoff classify as frequent
        frequentbidders(end+1,:)=[i size(bidaddress{i,1},1)];
    end
end