clear
clf

cd /home/jakub/Matlab/Nuno
%load ecb_main_50_old.mat
%load ecb_main_mro_50_M3_733890.mat % only 2 BS draws
%load ecb_main_50_M2_733733.mat
%load /home/jakub/Matlab/Nuno/asymmetric/ecb_main_50_M2_733714.mat
%load /home/jakub/Matlab/Nuno/asymmetric/ecb_main_50_M1_733714.mat
%load /home/jakub/matlab_results/Nuno/ecb_main_50_M1_733736.mat
%load /home/jakub/matlab_results/Nuno/ecb_main_50_M2_733736.mat
%load ecb_main_mro_50_qreg_M3_733879.mat
load  /home/jakub/matlab_results/Nuno/ecb_main_mro_50_M3_B200_734262.mat
load('nuno.mat','agdata')

if exist('margvalall_adj','var')==0
    cutoff=5;  % above what percentage rate to trim marginal values
    premium=0.25; % substitute trimmed marg values by bid+this premium
    [margvalall_adj]=margvaladjust(margvalall,data,cutoff,premium);
end

auctions=size(agdata,1);
eonia=agdata(:,13); % swap rate
repo=agdata(:,14); % highest liquid collateral (secured)
euribor=agdata(:,15); % unsecured rate
clearrate=agdata(:,5); % market clearing rates in primary auction 

global pstep

pstep=0.005;

%Plot histogram of steps before and after:
[estim,bidsteps,bidstepscum,pgrid,invbidfunc,span]=dataread(data,0,1);
figure(501)
hist(bidsteps(1:span(32,3)))
title(['Histogram of the number of bidsteps before turmoil'])
figure(502)
hist(bidsteps(span(33,2):span(50,3)))
title(['Histogram of the number of bidsteps after turmoil'])
figure(503)
plot(ecdf(bidsteps(1:span(32,3))))
hold on
plot(ecdf(bidsteps(span(33,2):span(50,3))),'m-')
title(['Empirical CDF of the number of bidsteps'])
legend('Before Turmoil', 'After Turmoil','Location','East')


%Plot variance of bids across bidder-steps
%before:
first_std_pre=[];
first_std_post=[];
last_std_pre=[];
last_std_post=[];
for auction=1:50
    firstbid_pre=[];
    firstbid_post=[];
    lastbid_pre=[];
    lastbid_post=[];  
    for bidder=span(auction,2):span(auction,3)        
        if bidsteps(bidder,1)>=1 %this can be used to condition on the number of steps
            if bidder==1
                bidad=1;
            else
                bidad=bidstepscum(bidder-1,1)+1;
            end
                bidlast=bidstepscum(bidder,1);
            if auction<=32
                firstbid_pre=[firstbid_pre estim(bidad,5)-eonia(auction,1)];
                lastbid_pre=[lastbid_pre estim(bidlast,5)-eonia(auction,1)];
            else
                firstbid_post=[firstbid_post estim(bidad,5)-eonia(auction,1)];
                lastbid_post=[lastbid_post estim(bidlast,5)-eonia(auction,1)];
            end
        end
        %first_std_pre=[first_std_pre std(firstbid_pre)];
        %first_std_post=[first_std_post std(firstbid_post)];
    end
    if auction<=32
        first_std_pre=[first_std_pre std(firstbid_pre)];
        last_std_pre=[last_std_pre std(lastbid_pre)];
    else
        first_std_post=[first_std_post std(firstbid_post)];
        last_std_post=[last_std_post std(lastbid_post)];
    end
end
figure(505)
plot([first_std_pre first_std_post] );
title(['Std deviation of the bids'])
hold on
plot([last_std_pre last_std_post],'r' );
%plot(ones(1,17)*32, 0:0.005:0.08,'-.')
plot([32 32], [ 0.0 0.2], '-.')
plot(euribor-repo,'c')
legend('Std deviation of the bids at 1st step','Std deviation of the bids at last step', 'Turmoil','Secured-Unsecured Spread','Location','NorthWest')
xlabel('Auction')
ylabel('Basis Points')

spread=[euribor-repo [first_std_pre first_std_post]'];
disp(['Correlation spread-std dev of bids overall: ' mat2str(corrcoef([euribor-repo [first_std_pre first_std_post]']))])
disp(['Correlation spread-std dev of bids pre: ' mat2str(corrcoef([euribor(1:32)-repo(1:32) [first_std_pre]']))])
disp(['Correlation spread-std dev of bids post: ' mat2str(corrcoef([euribor(33:50)-repo(33:50) [ first_std_post]']))])

%Plot variance in values in first and last steps
%for auction=1:auctions
%end

aucv = [5:18]; % we will plot auction 5-15 and 40-50.
for i=1:length(aucv)
    auc=aucv(i);
    [estim1,bidsteps,bidstepscum,pgrid,invbidfunc,span]=dataread(data,auc,1);
    qvec=estim1(:,6);
    pvec = estim1(:,5); 
    sortp = sortrows([-pvec,qvec],1);
    sortp(:,1) = -sortp(:,1) - eonia(auc);
    sortp(:,2) = cumsum(sortp(:,2));
    
    [estim2,bidsteps,bidstepscum,pgrid,invbidfunc,span]=dataread(data,auc+32,1);
    qvec2 = estim2(:,6);
    pvec2 = estim2(:,5); 
    sortp2 = sortrows([-pvec2,qvec2],1);
    sortp2(:,1) = -sortp2(:,1) - eonia(auc+32);
    sortp2(:,2) = cumsum(sortp2(:,2));
    figure(200)
    hold on
    %just bids
    plot(sortp(:,2),sortp(:,1),'b-','LineWidth',2)
    plot(sortp2(:,2),sortp2(:,1),'r-.','LineWidth',2)
    legend('Aggregate Bid - EONIA (Before Turmoil)', 'Aggregate Bid - EONIA (After Turmoil)')
        xlabel('Quantity Share Demanded')
        ylabel('Yield (Bid) - EONIA')
        title(['       Bidding Behavior in Auctions      \newline (Each line corresponds to one auction)'])    
    axis([0 2 -0.1 0.35])
end

aucv = [1:50];
%aucv =[28 34]; % for plots of one aggregate bid and value in the paper

for i=1:length(aucv)
    auc=aucv(i);
    [estim,bidsteps,bidstepscum,pgrid,invbidfunc,span]=dataread(data,auc,1);
    qvec=estim(:,6);
    pvec = estim(:,5); 
    %estim(:,5)=data(:,5);  %price bid
    %estim(:,7)=data(:,11); %cumul q-bid
    %estim(:,6)=data(:,4)./data(:,9); % q-bid
    %estim(:,3)=data(:,9);  %Q for sale
    %estim(:,2)=data(:,2);  %auction ID
    %estim(:,4)=data(:,7);  %Bidder
    %estim(:,8)=data(:,8);  %Nothing
    %estim(:,1)=data(:,3);  %Bidder       
    biddervec = unique(estim(:,1));
    nbidder = length(biddervec);        

    margv_thisauc = [];    
    for bi = 1:nbidder
        %v_thisbi = margvalall{auc,1}(bi,:); % unadjusted marginal values
        v_thisbi = margvalall_adj{auc,1}(bi,:); %this uses  "adjusted" mv - outliers are eliminated                
        margv_thisauc = [margv_thisauc; v_thisbi(find(v_thisbi~=0))'];
    end
        
    qvec=estim(:,6);
    pvec = estim(:,5); 
    
    sortv = sortrows([-margv_thisauc, qvec],1);
    sortp = sortrows([-pvec,qvec],1);
    sortv(:,1) = -sortv(:,1) - eonia(auc);
    sortp(:,1) = -sortp(:,1) - eonia(auc);
    sortv(:,2) = cumsum(sortv(:,2)); 
    sortp(:,2) = cumsum(sortp(:,2));       
    
    % plot bid fn
    hold on;
    if auc<32
        figure(1)
        hold on
        plot(sortv(:,2),sortv(:,1),'r-',sortp(:,2),sortp(:,1),'b-')
        axis([0 2 -0.1 0.35])
        
        figure(2)
        hold on
        %just bids
        plot(sortp(:,2),sortp(:,1),'b-','LineWidth',2)
        axis([0 2 -0.1 0.35])
         
        figure(3)
        hold on
        %just values
        plot(sortv(:,2),sortv(:,1),'b-','LineWidth',2)
        axis([0 2 -0.1 0.35])
        
        figure(4)
        hold on
        %values and bidding before
        plot(sortv(:,2),sortv(:,1),'r-.',sortp(:,2),sortp(:,1),'b-')
        if model==1 % there is more shading when model 2 is used
            axis([0 2 -0.1 0.35])
        else
            axis([0 2 -0.05 0.15])
        end
        legend('Marg val - EONIA', 'Bid - EONIA')
        xlabel('Quantity Share Demanded')
        ylabel('Yield (Bid) - EONIA & Marg val - EONIA')
        if length(aucv)==2
            title(['Bidding behavior (-) and marginal values (-.) in auctions before turmoil (auction ' num2str(aucv(i)) ')'])
        else
            title(['Bidding behavior (-) and marginal values (-.) in auctions before turmoil'])
        end
        
    else
        figure(1)
        hold on
        plot(sortv(:,2),sortv(:,1),'m-',sortp(:,2),sortp(:,1),'c-')
        legend('Marg val - EONIA', 'Bid - EONIA')
        xlabel('Quantity Share Demanded')
        ylabel('Yield (Bid) - EONIA & Marg val - EONIA')
        title(['Bidding Behavior and marginal values in auctions'])
        
        figure(2) 
        hold on
        %just bids
        plot(sortp(:,2),sortp(:,1),'r-.','LineWidth',2)
         legend('Bid - EONIA (Before: blue solid, After: red dash-dot)')
         xlabel('Quantity Share Demanded')
         ylabel('Yield (Bid) - EONIA')
         title(['        Aggregate Bidding Behavior    \newline (Each line corresponds to an auction)'])
        
         %just values
        figure(3)
        hold on
        plot(sortv(:,2),sortv(:,1),'r-.','LineWidth',2)
        legend('Marg val - EONIA (Before: blue solid, After: red dash-dot)')
        axis([0 2 -0.1 0.5])
        xlabel('Quantity Share Demanded')
        ylabel('Yield (Valuation) - EONIA')
        title([' Aggregate Marginal Valuation Curves  \newline (Each line corresponds to an auction)'])
        
        figure(5)
        hold on
        %values and bidding before
        plot(sortv(:,2),sortv(:,1),'r-.',sortp(:,2),sortp(:,1),'b-')
        if model==1 % there is more shading when model 2 is used
            axis([0 2 -0.1 0.35])
        else
            axis([0 2 -0.1 1.5])
        end      
        legend('Marg val - EONIA', 'Bid - EONIA')
        xlabel('Quantity Share Demanded')
        ylabel('Yield (Bid) - EONIA & Marg val - EONIA')
        if length(aucv)==2
            title(['Bidding behavior (-) and marginal values (-.) in auctions after turmoil (auction ' num2str(aucv(i)) ')'])
        else
            title(['Bidding behavior (-) and marginal values (-.) in auctions after turmoil'])
        end
      
    end
    %axis([0 2 -0.1 0.1])
    %axis([0 2 -0.1 0.35])    
        if model==1 % there is more shading when model 2 is used
            axis([0 2 -0.1 0.35])
        else
            axis([0 2 -0.1 1.5])
        end      
    %pause;
end    

%Plot two aggregate bid curves and marginal value curve pre and post
%together with EUREPO and EURIBOR

aucv=[25 32 34 45];
for i=1:length(aucv)
    auc=aucv(i);
    [estim,bidsteps,bidstepscum,pgrid,invbidfunc,span]=dataread(data,auc,1);   
    biddervec = unique(estim(:,1));
    nbidder = length(biddervec);        

    margv_thisauc = [];    
    for bi = 1:nbidder
        v_thisbi = margvalall{auc,1}(bi,:); % unadjusted marginal values        
        %v_thisbi = margvalall_adj{auc,1}(bi,:); %this uses  "adjusted" mv - outliers are eliminated                
        margv_thisauc = [margv_thisauc; v_thisbi(find(v_thisbi~=0))'];
    end
        
    qvec=estim(:,6);
    pvec = estim(:,5);
    
    sortv = sortrows([-margv_thisauc, qvec],1);
    sortp = sortrows([-pvec,qvec],1);
    sortv(:,1) = -sortv(:,1);% - eonia(auc);
    sortp(:,1) = -sortp(:,1);% - eonia(auc);
    sortv(:,2) = cumsum(sortv(:,2)); 
    sortp(:,2) = cumsum(sortp(:,2));       
      figure(40+i)
        hold on
        %values and bidding before
        plot(sortv(:,2),sortv(:,1),'rv',sortp(:,2),sortp(:,1),'bx','MarkerSize',10)
        hold on
        plot([0:0.02:2],euribor(auc)*ones(101,1),'m-.','LineWidth',1.5)
        plot([0:0.02:2],repo(auc)*ones(101,1),'c-.','LineWidth',1.5)
        plot([0:0.02:2],eonia(auc)*ones(101,1),'k-.','LineWidth',1.5)
        plot(ones(1,6),2:1:7,'g-','LineWidth',1.5)
        if auc<=32 % there is more shading after turmoil
            axis([0 2 4.04 4.12])
        else
            axis([0 2 3.95 4.32])
        end
        legend('Marginal value', 'Bid', 'EURIBOR', 'EUREPO','EONIA','Supply')
        xlabel('Quantity Share Demanded')
        ylabel('Yield (Bid) & Marg value')
        if auc<=32
            title(['Bidding behavior and marginal values before turmoil (auction ' num2str(aucv(i)) ')'])
        else
            title(['Bidding behavior and marginal values after turmoil (auction ' num2str(aucv(i)) ')'])
        end
end

%Now plot two examples of bidding for 1 bidder before and after the
%turmoil:


auc=[28 40];
clearprice=agdata(auc,5);
%bidders=[8 4];
%bidders=[14 8]; %nice
%bidders=[20 12];
%bidders=[25 15];
%bidders=[29 18];
%bidders=[55 44];
%bidders=[279 235];
%bidders=[324 287]; %nicer
bidders=[343 309]; %nicer

%auc=[25 45];
%clearprice=agdata(auc,5);
%bidders=[9 4];
%bidders=[15 8];
%bidders=[26 16];
%bidders=[238 189];
%bidders[276 217];

%auc=[20 48];
%clearprice=agdata(auc,5);
%bidders=[23 23];
%bidders=[45 47];
%bidders=[82 65]; %nice 
%bidders=[225 204];
%bidders=[247 230]; % interesting guess after turmoil!
%bidders=[301 2760]; % interesting guess after turmoil!


% % This little routine finds the corresponding bidder in the second auction
bid_loop=0;
[estim1,bidsteps,bidstepscum1,pgrid1,invbidfunc1,span1]=dataread(data,auc(1),1);
[estim,bidsteps,bidstepscum,pgrid,invbidfunc,span]=dataread(data,auc(2),1);
%%
while bid_loop<size(bidstepscum1,1)
notinboth=1;
while notinboth==1
    bid_loop=bid_loop+1;
    match_bidder=estim1(bidstepscum1(bid_loop,1),1);
    last_add=find(estim(:,1)==match_bidder,1,'last');
    if isempty(last_add)==0 && estim(last_add,7)>0.01
        notinboth=0;
    end
end
%bidders=[bid_loop find(bidstepscum(:,1)==last_add,1,'last')];



pstep=0.0005;
for i=1:length(auc)
    [estim,bidsteps,bidstepscum,pgrid,invbidfunc,span]=dataread(data,auc(i),1);
    %Construct std errors for marg values
    margmin=[];
    margmax=[];
    for k=1:size(margvalall,2) %by bootdraws
        for m=1:size(margvalall_adj{auc(i),1},2) % by maximal bidsteps
            tempstd(k,m)=margvalall_adj{auc(i),k}(bidders(i),m);
        end
    end
    temp2=sort(tempstd);
    %margmin=margvalall_adj{auc(i),1}(bidders(i),1:bidsteps(bidders(i)))-std(tempstd(:,1:bidsteps(bidders(i))))*norminv(0.95);
    %margmax=margvalall_adj{auc(i),1}(bidders(i),1:bidsteps(bidders(i)))+std(tempstd(:,1:bidsteps(bidders(i))))*norminv(0.95);
    margmin=temp2(ceil((0.05/2)*size(margvalall,2)),:);
    margmax=temp2(ceil((1-(0.05/2))*size(margvalall,2)),:);
    
    figure(i+10)
    clf
    %subplot(2,1,i)
    bidderidentity=estim(bidstepscum(bidders(i),1),1);
    plot(invbidfunc(bidders(i),:),pgrid-eonia(auc(i)),'r-','LineWidth',2)
    hold on
    if bidders(i)==1
        begin=1;
    else
        begin=bidstepscum(bidders(i)-1,1)+1;
    end
    % unadjusted marginal value
    %plot(estim(begin:bidstepscum(bidders(i),1),7),margvalall{auc(i),1}(bidders(i),1:bidsteps(bidders(i)))-eonia(auc(i)),'bx')
    % adjusted marginal value
    plot(estim(begin:bidstepscum(bidders(i),1),7),margvalall_adj{auc(i),1}(bidders(i),1:bidsteps(bidders(i)))-eonia(auc(i)),'bo')
    hold on
    plot(0:0.01:1,ones(101,1)*clearprice(i)-eonia(auc(i)),'g--','LineWidth',2)
    plot(estim(begin:bidstepscum(bidders(i),1),7),margmin(1:bidsteps(bidders(i)))-eonia(auc(i)),'kx')
    plot(estim(begin:bidstepscum(bidders(i),1),7),margmax(1:bidsteps(bidders(i)))-eonia(auc(i)),'kx')
    if i>1
        %axis([max(0,min(estim(begin:bidstepscum(bidders(i),1),7))-0.003) max(estim(begin:bidstepscum(bidders(i),1),7))+0.003 min(estim(begin:bidstepscum(bidders(i),1),5)-0.05)-eonia(auc(i)) max(estim(begin:bidstepscum(bidders(i),1),5))+0.35-eonia(auc(i))])
        axis([max(0,min(estim(begin:bidstepscum(bidders(i),1),7))-0.003) max(estim(begin:bidstepscum(bidders(i),1),7))+0.003 min(estim(begin:bidstepscum(bidders(i),1),5)-0.05)-eonia(auc(i)) max(estim(begin:bidstepscum(bidders(i),1),5))+0.58-eonia(auc(i))])
    else
        axis([max(0,min(estim(begin:bidstepscum(bidders(i),1),7))-0.003) max(estim(begin:bidstepscum(bidders(i),1),7))+0.003 min(estim(begin:bidstepscum(bidders(i),1),5)-0.05)-eonia(auc(i)) max(estim(begin:bidstepscum(bidders(i),1),5))+0.1-eonia(auc(i))])
    end
    legend('Bid','Marg value','Clearing Price', '95% CI')
    xlabel('Quantity Share Demanded')
    ylabel('Yield (Bid) - EONIA & Marg val - EONIA')
    if auc(i)<32
        title(['Bids and estimated marginal values before turmoil (bider ' num2str(bidderidentity) ')'])
    else
        title(['Bids and estimated marginal values after turmoil (bider ' num2str(bidderidentity) ')'])
    end
    for j=1:bidsteps(bidders(i),1)
        %text(estim(begin-1+j,7),margvalall_adj{auc(i),1}(bidders(i),j)-eonia(auc(i)),[num2str((margvalall_adj{auc(i),1}(bidders(i),j)-eonia(auc(i))-floor((margvalall_adj{auc(i),1}(bidders(i),j)-eonia(auc(i)))/100)*100)) '\rightarrow '],'HorizontalAlignment','right')
        if margvalall_adj{auc(i),1}(bidders(i),j)-eonia(auc(i))>=0
            text(estim(begin-1+j,7),margvalall_adj{auc(i),1}(bidders(i),j)-eonia(auc(i)),['   \leftarrow ' num2str((margvalall_adj{auc(i),1}(bidders(i),j)-eonia(auc(i))-floor((margvalall_adj{auc(i),1}(bidders(i),j)-eonia(auc(i)))/100)*100))],'HorizontalAlignment','left')
        else
            text(estim(begin-1+j,7),margvalall_adj{auc(i),1}(bidders(i),j)-eonia(auc(i)),['   \leftarrow ' num2str((margvalall_adj{auc(i),1}(bidders(i),j)-eonia(auc(i))-ceil((margvalall_adj{auc(i),1}(bidders(i),j)-eonia(auc(i)))/100)*100))],'HorizontalAlignment','left')
        end
        hold on
    end
    
end
%pause
end
%%
pstep=0.005;


% aggregate plot of interest rates
figure(100)
plot(eonia,'r-x')
hold on
plot(repo,'b-o')
plot(euribor,'g')
plot([32 32], [3.5 4.5], '-.')
axis([0 50 3.5 4.5])
legend('1-w swap rate (EONIA)','1-w repo rate (EUREPO)','1-w unsecured rate (EURIBOR)','Turmoil','Location','NorthWest')
xlabel('Auction')
ylabel('Yield')
title(['Interest rates'])

% plot difference between secured and unsecured lending rates
figure(101)
hold on
plot([32 32], [ 0.02 0.2], '-.')
plot(euribor-repo,'b')
%legend('Difference between 1-w repo rate (EUREPO) and 1-w unsecured rate (EURIBOR)')
axis([0 50 0.02 0.2])
%xlabel('Auction')
xlabel('Week')
ylabel('Spread')
title(['Difference between 1-w unsecured rate (EURIBOR) and 1-w repo rate (EUREPO)'])
legend('August 9, 2007 (week 32)','Location','NorthWest')


figure(102)
hold on
plot(repo-eonia,'b')
plot([32 32], [ -0.1 0.2], '-.')
%legend('Difference between 1-w repo rate (EUREPO) and 1-w unsecured rate (EURIBOR)')
axis([0 50 -0.1 0.1])
xlabel('Auction')
ylabel('Yield')
title(['Difference between 1-w repo rate (EUREPO) and 1-w swap rate (EONIA)'])

% aggregate plot of interest rates & clearing rates
figure(99)
%plot(eonia,'r-x')
hold on
plot(repo,'b-o')
plot(euribor,'g')
plot(clearrate,'m-x')
plot([32 32], [3.5 4.5], '-.') %MROs
%plot([11 11], [3.0 5.5], '-.') %LTROs
axis([0 50 3.5 4.5]) %MROs
%axis([0 19 3.0 5.5]) %LTROs
%legend('1-w swap rate (EONIA)','1-w repo rate (EUREPO)','1-w unsecured rate (EURIBOR)','Clearing rate','Turmoil','Location','NorthWest')
legend('1-w repo rate (EUREPO)','1-w unsecured rate (EURIBOR)','Clearing rate','Turmoil','Location','NorthWest')
xlabel('Auction')
ylabel('Yield')
title(['Interest rates'])

% Plot means and std dev of bid distributions by bidder groups:
%load ecb_main_mro_50_M3_733890.mat
%meanp_G1=meanp(:,Group1);
%meanp_G2=meanp(:,Group2);
for j=1:size(meanp,1)
    temp=meanp(j,Group1);
    meanp_G1(j,1)=mean(temp(temp>0));
    sdm_G1(j,1)=std(temp(temp>0));
    temp=meanp(j,Group2);
    meanp_G2(j,1)=mean(temp(temp>0));
    sdm_G2(j,1)=std(temp(temp>0));
    temp=stddevp(j,Group1);
    stddevp_G1(j,1)=mean(temp(temp>0));
    sdsdp_G1(j,1)=std(temp(temp>0));
    temp=stddevp(j,Group2);
    stddevp_G2(j,1)=mean(temp(temp>0));
    sdsdp_G2(j,1)=std(temp(temp>0));
end

figure(108)
subplot(2,2,2)
hold on
plot(1:50,stddevp_G1*100,'LineWidth',1)
plot(1:50,stddevp_G2*100,'r','LineWidth',1)
plot(ones(1,2)*32, [0 6],'-.')
%legend('Std deviation','Turmoil','Location','NorthWest')
legend('Healthy','Distressed','Turmoil','Location','NorthWest')

xlabel('Auction')
ylabel('Mean of Std dev of p^{c} (in basis points)')
title('Mean of Standard Deviation of p^{c}')

subplot(2,2,1)
hold on
plot(1:50,meanp_G1,'LineWidth',1)
plot(1:50,meanp_G2,'r','LineWidth',1)
plot(ones(1,2)*32, [3.4 4.8],'-.')
axis([ 0 50 3.4 4.6])
%legend('Mean of Mean of p^{c}','Turmoil','Location','NorthWest')
%legend('Healthy','Distressed','Turmoil','Location','NorthWest')

xlabel('Auction')
ylabel('Mean of Mean of p^{c}')
title('Mean of Mean of p^{c}')

%figure(109)
subplot(2,2,3)
hold on
plot(1:50,sdm_G1*100,'LineWidth',1)
plot(1:50,sdm_G2*100,'r','LineWidth',1)
plot(ones(1,2)*32, [0 0.45],'-.')
axis([ 0 50 0 0.35])
%legend('Healthy','Distressed','Turmoil','Location','NorthWest')
xlabel('Auction')
ylabel('Std Dev of Mean of p^{c} (in basis points)')
title('Std Dev of Mean  of p^{c}')

subplot(2,2,4)
hold on
plot(1:50,sdsdp_G1*100,'LineWidth',1)
plot(1:50,sdsdp_G2*100,'r','LineWidth',1)
plot(ones(1,2)*32, [0 0.45],'-.')
axis([ 0 50 0 0.35])
%legend('Healthy','Distressed','Turmoil','Location','NorthWest')
xlabel('Auction')
ylabel('Std Dev of Std Dev of p^{c} (in basis points)')
title('Std Dev of Std Dev of p^{c}')

% % subtract EONIA rate from the avg marginal value
eonia=agdata(:,13);
[margvalall_adj]=margvaladjust(margvalall,data,4.5,0.1);
[allavgmarg,allavgmargstd,avgmarg,allavgmarg_unw,allavgmargstd_unw,avgmarg_unw]=avgmargval(margvalall_adj,data);
mv_premium=allavgmarg-repmat(eonia,1,size(allavgmarg,2));
mv_premium_unw=allavgmarg_unw-repmat(eonia,1,size(allavgmarg,2));
riskpremium=agdata(:,14)-agdata(:,13); %repo rate - eonia swap

%plot (repo rate - EONIA swap rate) difference
figure(1)
plot(riskpremium,'Linewidth',2)
title('Repo rate - EONIA difference')

%plot q-weighted avg marg value - EONIA difference
mv_pre_std=std(mv_premium')';
figure(2)
plot(mv_premium(:,1)*100,'b-','Linewidth',2)
hold on
plot(ones(1,2)*32, [-0.1 0.6]*100,'-.')
plot(100*(mv_premium(:,1)+norminv(0.975)*mv_pre_std),'r--');
plot(100*(mv_premium(:,1)-norminv(0.975)*mv_pre_std),'r--');
xlabel('Auction')
ylabel('Basis Points')
legend('Average Marginal Values - EONIA','Turmoil','95% CI', 'Location','NorthWest')
title('Quantity-Weighted Avg Marg Value - EONIA Difference')

%plot unweighted avg marg value - EONIA difference
figure(3)
plot(mv_premium_unw(:,1))
title('Unweighted avg marg value - EONIA difference')

%plot q-weighted bid rate
figure(4)
plot(agdata(:,8))
title('Quantity weighted bid')

%plot q-weighted bid rate - EONIA difference
figure(5)
plot(agdata(:,8)-eonia)
title('Quantity weighted bid - EONIA difference')

%plot both EONIA adjusted q-weighted bid and avg margval
figure(6)
plot(agdata(:,8)-eonia,'r','Linewidth',2)
hold on
plot(mv_premium(:,1),'Linewidth',2)
legend('Q-weighted bid', 'Q-weighted marginal value')
title('Quantity weighted bid and marginal value - EONIA difference')

figure
subplot(1,2,1)
hold on
plot(riskpremium,'Linewidth',2)
title('Repo rate - EONIA difference')
subplot(1,2,2)
hold on
plot(agdata(:,8)-eonia,'r','Linewidth',1)
hold on
plot(mv_premium(:,1),'Linewidth',1)
legend('Q-weighted bid', 'Q-weighted marginal value')
title('Quantity weighted bid and marginal value - EONIA difference')

%%%%%%%%%% EFFICIENCY %%%%%%%%%%%%%%%%

%replace NaN entries in margvalall
% markup=0.1;
% for auctiongroup=1:auctions    
%     [estim,bidsteps,bidstepscum,pgrid,invbidfunc]=dataread(data,auctiongroup,aucgroupsize); 
%     datasize=size(invbidfunc);
%     for boot=1:size(margvalall,2)
%             %round marginal values to the nearest pstep
%             margvalall{auctiongroup,boot}=round(margvalall{auctiongroup,boot}/pstep)*pstep;
%             for bidder=1:datasize(1,1)
%                 for step=1:bidsteps(bidder,1)
%                    %First replace NaN entries in the margval matrix with the bid+markup (``lower
%                    %bound''+markup on marginal valuation)
%                    if isnan(margvalall{auctiongroup,boot}(bidder,step))==1
%                        if bidder>1
%                            margvalall{auctiongroup,boot}(bidder,step)=estim(bidstepscum(bidder-1,1)+step,5)+markup;
%                        else
%                            margvalall{auctiongroup,boot}(bidder,step)=estim(step,5)+markup;
%                        end
%                    end  
%                 end
%                 %corrects all margval to be nonincreasing  
%                 margvalall{auctiongroup,boot}(bidder,:)=sort(margvalall{auctiongroup,boot}(bidder,:),'descend');
%             end            
%     end
% end


%plot of suplus from the actual allocation relative to a random allocation
%surplus (i.e., efficiency measure)
if exist('effi','var')==0
    rand('twister', 6012456489); %let's fix some random seed
    [effi,effSE,grossuref,allocdummy]=efficiency(margvalall,data);
    [effirnd,effrndSE,percentcovered,percent_SE,percentcov,actgrossur,grossurrnd]=efficiency_rnd(margvalall,data,grossuref);
    %effrndSE(effrndSE>100)=0.02;
end

figure(102)
plot(effi)
hold on
plot(effi-1.96*effSE,'--r')
hold on
plot(ones(1,14)*32, 0.935:0.005:1,'-.')
plot(effi+1.96*effSE,'--r')
axis([ 0 51 0.65 1])
legend('Efficiency (Achieved Surplus / Efficient Surplus)','95% confidence interval', 'Turmoil','Location','SouthWest')
xlabel('Auction')
ylabel('Efficiency (Achieved Surplus / Efficient Surplus)')
title('Efficiency of Actual Auctions')


figure(103)
plot(effirnd)
hold on
plot(effirnd-1.96*effrndSE,'--r')
hold on
plot(ones(1,111)*32, 0.7:0.005:1.25,'-.')
plot(effirnd+1.96*effrndSE,'--r')
axis([ 0 51 0.98 1.05])
%axis([ 0 51 0.85 1.25])
legend('Achieved Surplus / Surplus from a Random Allocation','95% confidence interval', 'Turmoil','Location','SouthWest')
xlabel('Auction')
ylabel('Achieved Surplus / Surplus from a Random Allocation')
title('Performance of Discriminatory Auction Mechanism')
disp(['Mean performance pre-turmoil: ' num2str(mean(effirnd(1:32)))])
disp(['Mean performance post-turmoil: ' num2str(mean(effirnd(33:end)))])
disp(['Improvement in percent: ' num2str((mean(effirnd(33:end))/mean(effirnd(1:32))-1)*100)])
disp(['Improvement in beating the random alloc: ' num2str((mean(effirnd(33:end))-1)/(mean(effirnd(1:32))-1))])

figure(104)
plot(percentcovered)
hold on
plot(percentcovered-1.96*percent_SE,'--r')
hold on
plot(ones(1,391)*32, -0.7:0.005:1.25,'-.')
plot(percentcovered+1.96*percent_SE,'--r')
axis([ 0 51 -0.6 1])
legend('(Achieved S - Random Al S) / (Efficient S - Random S)','95% confidence interval', 'Turmoil','Location','SouthWest')
xlabel('Auction')
ylabel('(Achieved S - Random Al S) / (Efficient S - Random S)')
title('Performance of Discriminatory Auction Mechanism')

%use 'margvalall_adj' - eliminated outliers and imposed downward sloping
% values
 cutoff=4.5;  % above what percentage rate to trim marginal values
 premium=0.1; % substitute trimmed marg values by bid+this premium
 [margvalall_adj]=margvaladjust(margvalall,data,cutoff,premium);
if exist('effi_adj','var')==0
    rand('twister', 6032456489); %let's fix some random seed
    [effi_adj,effSE_adj,grossuref_adj,allocdummy]=efficiency(margvalall_adj,data);
    [effirnd_adj,effrndSE_adj,percentcovered_adj,percent_SE_adj,percentcov_adj,actgrossur_adj,grossurrnd_adj]=efficiency_rnd(margvalall_adj,data,grossuref_adj);
end

figure(105)
plot(effi_adj)
hold on
plot(effi_adj-1.96*effSE_adj,'--r')
hold on
plot(ones(1,14)*32, 0.935:0.005:1,'-.')
plot(effi_adj+1.96*effSE_adj,'--r')
axis([ 0 51 0.975 1])
legend('Efficiency (Achieved Surplus / Efficient Surplus)','95% confidence interval', 'Turmoil','Location','SouthWest')
xlabel('Auction')
ylabel('Efficiency (Achieved Surplus / Efficient Surplus)')
title('Efficiency of Actual Auctions')

figure(206)
plot(effirnd_adj,'Linewidth',2)
hold on
plot(effirnd_adj-1.96*effrndSE_adj,'--r')
hold on
plot(ones(1,111)*32, 0.7:0.005:1.25,'-.')
plot(effirnd_adj+1.96*effrndSE_adj,'--r')
axis([ 0 51 0.986 1.012])
legend('Achieved Surplus / Surplus from a Random Allocation','95% confidence interval', 'Turmoil','Location','NorthWest')
xlabel('Auction')
ylabel('Achieved Surplus / Surplus from a Random Allocation')
title('Performance of Discriminatory Auction Mechanism')
disp(['Mean performance pre-turmoil: ' num2str(mean(effirnd_adj(1:32)))])
disp(['Mean performance post-turmoil: ' num2str(mean(effirnd_adj(33:end)))])
disp(['Improvement in percent: ' num2str((mean(effirnd_adj(33:end))/mean(effirnd_adj(1:32))-1)*100)])
disp(['Improvement in beating the random alloc: ' num2str((mean(effirnd_adj(33:end))-1)/(mean(effirnd_adj(1:32))-1))])

figure(107)
plot(percentcovered_adj,'Linewidth',2)
hold on
plot(percentcovered_adj-1.96*percent_SE_adj,'--r')
hold on
plot(ones(1,391)*32, -0.7:0.005:1.25,'-.')
plot(percentcovered_adj+1.96*percent_SE_adj,'--r')
axis([ 0 51 -3 1])
%legend('(Achieved S - Random Alloc S) / (Efficient S - Random Alloc S)','95% confidence interval', 'Turmoil','Location','SouthWest')
xlabel('Auction')
ylabel('(Achieved S - Random Alloc S) / (Efficient S - Random Alloc S)')
title('Performance of Discriminatory Auction Mechanism')
