function[psort,pdistr,range,meanp,stddevp]=pricedist(bidder,invbidfunc,ressup)

% this function computes the simulated distribution of the market clearing prices by
% intersecting bidder's bid with the resampled residual supplies. It also
% delivers mean and std dev of this distribution.

global resamplingdraws pgrid pstep
pclear=zeros(resamplingdraws,3);
datasize=size(invbidfunc);

for j=1:resamplingdraws
    %Determine the (highest) market clearing price corresponding to the current residual supply
    for p=datasize(1,2):-1:1
        if ressup(j,p)-invbidfunc(bidder,p)<=0
            if ressup(j,p)-invbidfunc(bidder,p)<0
                if ressup(j,min(p+1,datasize(1,2)))-invbidfunc(bidder,min(p+1,datasize(1,2)))>0 %i.e. res supply cuts the horizontal piece of bid
                    pclear(j,1)=pgrid(1,p);
                    pclear(j,2)=invbidfunc(bidder,p);
                    pclear(j,3)=ressup(j,p);
                else %In this case it cuts the vertical part of the bid, and hence the market will clear on a price+1
                    pclear(j,1)=pgrid(1,min(p+1,datasize(1,2))); %If ressup would be too low, then rationing, but i gets fully served on vertical step in ressup
                    pclear(j,2)=invbidfunc(bidder,min(p+1,datasize(1,2)));
                    pclear(j,3)=ressup(j,min(p+1,datasize(1,2)));
                end
            else
                %pclear(j,2)=ressup(j,p); If they are the same, then no problem
                pclear(j,1)=pgrid(1,p);
                pclear(j,2)=invbidfunc(bidder,p);
                pclear(j,3)=ressup(j,p);
            end
            break
        end
    end
end
psort=sort(pclear);

%added on April 24th, 2009: (to get bidder's perceived uncertainty
j=1;
while psort(j,1)==0, if j==size(psort,1), break, end, j=j+1; end %this eliminates for the moment simulated states in which market does not clear!
psortpos=psort(j:end,:);
range=min(psortpos(:,1)):pstep:max(psortpos(:,1)); %range for support of smoothed density of market clearing price
[pdistr]=ksdensity(psortpos(:,1),range); %obtain non-parametric estimate of the distribution
meanp=pdistr*range'/(sum(pdistr));
stddevp=sqrt(pdistr*(range.^2)'/(sum(pdistr))-meanp^2);
