function[shadingall,shading_avg]=shading(margvalall,data)

%Function 'shading' computes the shading factor at
%each estimated step and also the q-weighted (by quantity-demands) 
%averages of shading factors


global aucgroupsize auctions
shading_avg=mat2cell(zeros(auctions/aucgroupsize,size(margvalall,2)),auctions/aucgroupsize,size(margvalall,2));

for auctiongroup=1:auctions/aucgroupsize
    [estim,bidsteps,bidstepscum]=dataread(data,auctiongroup,aucgroupsize);    
    for boot=1:size(margvalall,2)
        shadingall{auctiongroup,boot}=zeros(size(margvalall{auctiongroup,boot},1),size(margvalall{auctiongroup,boot},2));       
        shading_avg{auctiongroup,boot}=zeros(size(margvalall{auctiongroup,boot},1),1);       
        for bidder=1:size(margvalall{auctiongroup,boot},1)
            for step=1:bidsteps(bidder,1) 
                % Get quantity-weighted averages of marginal values by bidders in an auction
                % and get the unweighted average
                if bidder>1
                    shadingall{auctiongroup,boot}(bidder,step)=margvalall{auctiongroup,boot}(bidder,step)-estim(bidstepscum(bidder-1,1)+step,5);
                    shading_avg{auctiongroup,boot}(bidder,1)=shading_avg{auctiongroup,boot}(bidder,1)+(margvalall{auctiongroup,boot}(bidder,step)-estim(bidstepscum(bidder-1,1)+step,5))*estim(bidstepscum(bidder-1,1)+step,6);                   
                else
                    shadingall{auctiongroup,boot}(bidder,step)=margvalall{auctiongroup,boot}(bidder,step)-estim(step,5);
                    shading_avg{auctiongroup,boot}(bidder,1)=shading_avg{auctiongroup,boot}(bidder,1)+(margvalall{auctiongroup,boot}(bidder,step)-estim(step,5))*estim(step,6);
                end
            end
            if bidder>1
                shading_avg{auctiongroup,boot}(bidder,1)=shading_avg{auctiongroup,boot}(bidder,1)/estim(bidstepscum(bidder-1,1)+bidsteps(bidder,1),7);               
            else                
                shading_avg{auctiongroup,boot}(bidder,1)=shading_avg{auctiongroup,boot}(bidder,1)/estim(bidsteps(bidder,1),7);
            end
        end     
    end  
end