estimates clear
tempfile agdata
tempfile agdata_mro
tempfile agdata_ltro
set mem 300m 
cd d:\ecb2007\alpha

insheet using agdata.txt, clear

rename v1 auc
rename v2 mro
gen aucID = string(v3, "%11.0g")
drop v3
rename v4 duration
rename v5 minbidq
rename v6 MBR 
*min bid rate of ECB 
rename v7 mktclr
rename v8 rationing
rename v9 expost_supply
rename v10 qwpbid
rename v11 total_demand
rename v12 N
rename v13 minbid
rename v14 maxbid
rename v15 eonia
rename v16 eurepo
rename v17 euribor
drop v18 

sort aucID
save `agdata', replace

clear

use `agdata'
keep if mro==1
sort auc
save `agdata_mro', replace


clear
use `agdata'
keep if mro==0
sort auc
save `agdata_ltro', replace

insheet using alpha_mro.txt, clear

rename v1 auc
rename v2 bidder
rename v3 country
rename v4 alpha
rename v5 alloted
rename v6 max_dem

sort auc
merge auc using `agdata_mro'

tab _merge

drop _merge

gen countryname=""
replace countryname="AT" if country==1
replace countryname="BE" if country==2
replace countryname="ES" if country==4
replace countryname="DE" if country==3
replace countryname="FI" if country==5
replace countryname="FR" if country==6
replace countryname="GR" if country==7
replace countryname="IE" if country==8
replace countryname="IT" if country==9
replace countryname="LU" if country==10
replace countryname="NL" if country==11
replace countryname="PT" if country==12
replace countryname="SI" if country==13
sort bidder aucID

g cens_alpha=alpha
replace cens_alpha=1 if cens_alpha>1
replace cens_alpha=. if alpha==0
saveold alpha_panel_s10, replace 

use alpha_panel_s10, clear
drop if country==0
g pre=auc<=32
collapse cens_alpha alpha country, by(pre bidder)
egen m_al=mean(cens_alpha), by(pre country)
gsort -pre -m_al
tempfile working
save `working', replace
g temp=country[_n]!=country[_n-1]
g sort_country=sum(temp)
keep if pre==1
keep country sort_country
collapse country, by(sort_country)
tempfile count_dict
save `count_dict', replace
use `working', clear
merge m:1 country using `count_dict'

g post=1-pre
graph box cens_alpha, over(post) over(sort_country) noout yscale(r(-4,2)) asyvars title("Distribution of alphas (by country)") ///
ytitle("Alpha") legend(label(1 "Before") label(2 "After")) note("Countries sorted by mean alpha before crisis")
*graph export alpha_cens.eps, as(eps) preview(on) replace

*graph box cens_alpha if auc<=32, over(countryname) noout yscale(r(-6,2))
*graph box cens_alpha if auc>32, over(countryname) noout

insheet using signif_mro.csv, names clear
rename v1 bidder
rename v2 partic
rename v3 coeff
rename v4 se_coeff
tempfile signifmro
sort bidder
save `signifmro', replace
use alpha_panel_s10, clear
drop if country==0
g pre=auc<=32
merge bidder using `signifmro'
tab _merge
drop _merge
g hardhit=coeff>0 & coeff!=.
replace alpha=. if alpha==0
tempfile alphamerged
save `alphamerged'
* trim outliers
replace alpha=. if alpha<-3
replace alpha=. if alpha>3
collapse cens_alpha alpha country hardhit, by(pre bidder)
su alpha, de
bysort pre: su alpha, de
bysort pre hardhit: su alpha, de

* now impute alpha=1 if not participating:
use `alphamerged', clear
replace alpha=. if alpha<-3
replace alpha=. if alpha>3
collapse cens_alpha alpha country hardhit, by(pre bidder)
replace alpha=1 if alpha==.
bysort pre hardhit: su alpha, de

*bysort pre: su alpha if alpha>-3 & alpha<3, de
*bysort pre hardhit: su alpha if alpha>-3 & alpha<3, de
replace alpha=1 if alpha==.
bysort pre hardhit: su alpha if alpha>-3 & alpha<3, de
