cd d:/ECB2007
tempfile pcamv
tempfile pcamerged
* principal component analysis
insheet using Table5_mv_all.csv, clear names
rename tenderid tenderid_num
mvdecode b*, mv(0)
foreach var of varlist b* {
qui su `var'
local obs=r(N)
if `obs'<=49 {
	drop `var'
	}
	else {
	local bidders=`bidders'+1
	}
}
di `bidders'
pca b*
* about 80% explained by 1st PC, 5 PCs explain 95%
pca b*, factors(7)
save `pcamv', replace

* now pca pre and post: (36% explained by 1st PC after crisis, 90% before crisis)
g aucid=_n
pca b* if aucid<=32, factors(5)
pca b* if aucid>32, factors(5)

* now take out the EONIA interest rate from values:
tempfile agdatamro
insheet using Table5_mro_agdata.csv, clear names
rename t_ref tenderid_num 
keep tenderid_num t_allot_dt dax t_duration eoniaswaprate1w eurepo1wreporate euribor1w
g alot_date=date(t_allot_dt,"MDY")
format alot_date %d
g matur_date= alot_dat+t_duration
format matur_date %d
save `agdatamro'
use `pcamv', clear
merge 1:1 tenderid_num using `agdatamro'
drop _merge
save `pcamerged', replace
foreach var of varlist b2-b712 {
	qui replace `var'=`var'-eoniaswaprate1w
}
* ok, variance explained by 1st PC drops to 57%, 5 PCs explain 85%.
pca b*, factors(7)
* now pca pre and post: 
* after taking out the eonia:
* 43% explained by 1st PC after crisis, and 64% before crisis)
g aucid=_n
pca b* if aucid<=32, factors(5)
pca b* if aucid>32, factors(5)

insheet using bids.csv, clear names
rename tenderid tenderid_num
mvdecode b*, mv(0)
foreach var of varlist b* {
qui su `var'
local obs=r(N)
if `obs'<=49 {
	drop `var'
	}
	else {
	local bidders=`bidders'+1
	}
}
di `bidders'
pca b*
* 99.5% explained by the 1st PC.
pca b*, factors(7)
* now pca pre and post:
g aucid=_n
pca b* if aucid<=32, factors(5)
pca b* if aucid>32, factors(5)
merge 1:1 tenderid_num using `agdatamro'
drop _merge
foreach var of varlist b2-b712 {
	qui replace `var'=`var'-eoniaswaprate1w
}
* ok, variance explained by 1st PC drops to 94%, 5 PCs explain 98%.
pca b*, factors(7)

********** TRY IF MV ARE CORRELATED WITH FUTURE REPO RATES OR SPREADS
use `pcamerged', clear
g spread=euribor1w-eurepo1wreporate
sort alot_date
g aucid=_n
tsset aucid
foreach var of varlist b2-b712 {
	local var2 "F_EON_`var'"
	qui g `var2'=`var'-F.eoniaswaprate1w
	local var2 "EON_`var'"
	qui g `var2'=`var'-eoniaswaprate1w
	local var2 "F_repo_`var'"
	qui g `var2'=`var'-F.eurepo1wreporate
	local var2 "repo_`var'"
	qui g `var2'=`var'-eurepo1wreporate
	local var2 "F_spread_`var'"
	qui g `var2'=`var'-F.spread
	local var2 "spread_`var'"
	qui g `var2'=`var'-spread
	*qui replace `var'=`var'-f.eoniaswaprate1w
}

**** OK, 3 PCAs seem to "predict" better 1-w forward spread after crisis
* 1st: 90, 3: 98
pca F_spread* if aucid<=32, factors(3)
* 1st 40, 3: 67
pca F_spread* if aucid>32, factors(3)
* 1st: 90, 3: 98
pca spread_* if aucid<=32, factors(3)
* 1st 30, 3: 62
pca spread_* if aucid>32, factors(3)

**** OK, sae with repo: 3 PCAs seem to "predict" better 1-w forward repo after crisis, but also before!
* 1st: 70, 3: 93
pca F_repo* if aucid<=32, factors(3)
* 1st: 44, 3: 73
pca F_repo* if aucid>32, factors(3)
* 1st: 56, 3: 83
pca repo* if aucid<=32, factors(3)
* 1st: 39, 3: 70
pca repo* if aucid>32, factors(3)

*** same with EONIA
* 1st expl 70%, 3: 93
pca F_EO* if aucid<=32, factors(3)
* 1st 50, 3: 75
pca F_EO* if aucid>32, factors(3)
* 1st expl 64%, 3: 85
pca EO* if aucid<=32, factors(3)
* 1st 43, 3: 74
pca EO* if aucid>32, factors(3)

reshape long b F_spread_b spread_b F_EON_b EON_b F_repo_b repo_b, i(aucid) j(bidder_num)
xtset bidder_num aucid
* again contemporaneous is predicted better!
xtreg F.eurepo1wreporate b, fe
xtreg eurepo1wreporate b, fe

* what if taking differences?
xtreg D.eurepo1wreporate D.b, fe

* now with DAX (german stock index)
xtreg F.eurepo1wreporate b dax, fe
xtreg eurepo1wreporate b dax, fe
xtreg F.euribor1w b dax, fe
xtreg euribor1w b dax, fe

* now allow for different correlations after crisis:
g turmoil=aucid>32
g turmoil_b=turmoil*b
xtreg F.eurepo1wreporate b turmoil* , fe
xtreg eurepo1wreporate b turmoil*, fe
xtreg D.eurepo1wreporate D.b turmoil* , fe
xtreg F.euribor1w b turmoil* , fe
xtreg euribor1w b turmoil*, fe
xtreg D.euribor1w D.b turmoil* , fe
