/*
tempfile cdsdef
tempfile intrates
tempfile agdataltro
tempfile agdatamro
tempfile bidderlist
tempfile ltroout
tempfile defic

cd d:/ECB2007
insheet using Table5_CDS_Def_2007.csv, clear names
g def2=real(def)
drop def
g alot_date=date(mrallotdate,"MDY")
format alot_date %d
rename bankcode bidderid
save `cdsdef', replace

insheet using Table5_bidder_dict.csv, clear names
save `bidderlist'

insheet using Table5_int_rates.csv, clear names
g aucdate=date(date,"MDY")
format aucdate %d
drop if aucdate==.
save `intrates', replace

insheet using Table5_deficiency.csv, clear names
drop b0 v* day
rename cuaceurthousands date
g aucdate=date(date,"MD20Y")
foreach var of varlist b2-b731 {	 
	*su `var'
	local num=substr("`var'",2,.)
	g bidder`num'=real(`var')
	*replace `var'=real(`var')
	}
keep aucdate bidder*
reshape long bidder, i(aucdate) j(biddernum)
rename bidder deficiency
* create merging date variable: want the day-before auction date
g alot_date=aucdate+1
save `defic', replace
	
insheet using Table5_ltro_agdata.csv, clear names
rename t_ref tenderid_num 
keep tenderid_num t_allot_dt t_maturity_dt t_marginal_rate t_alloted_amount t_allotment_at_marginal_rate
g alot_date=date(t_allot_dt,"MDY")
format alot_date %d
g matur_date=date(t_maturity_dt,"MDY")
format matur_date %d
save `agdataltro'

insheet using Table5_mro_agdata.csv, clear names
rename t_ref tenderid_num 
keep tenderid_num t_allot_dt dax t_duration eoniaswaprate1w eurepo1wreporate euribor1w
g alot_date=date(t_allot_dt,"MDY")
format alot_date %d
g matur_date= alot_dat+t_duration
format matur_date %d
save `agdatamro'



insheet using Table5_ltro_data.csv, clear names
merge m:1 tenderid_num using `agdataltro'
drop _merge
* obtain aggregate amount won in an LTRO
keep if rate>=t_marginal_rate
bysort tenderid_num: g temp=sum(volume) if rate==t_marginal_rate
bysort tenderid_num: egen marg_dem=max(temp)
drop temp
g ratcoef=t_allotment_at_marginal_rate/100
g alloc=volume
replace alloc=volume*ratcoef if rate==t_marginal_rate
bysort tenderid_num: g temp=sum(alloc)
bysort tenderid_num: egen total=max(temp)
drop temp
* ok, total allocation seem to coincide
keep bidderid alot_date matur_date alloc
sort bidderid alot_date
collapse (sum) alloc, by(bidderid alot_date matur_date)
* create outstanding LTROs by week (1/1/2007 is 17,167)
forvalues i=1/52 {
local mind=17160+`i'*7
qui g temp=alloc if matur_date>`mind' & alot_date<=`mind'
qui bysort bidderid: g temp2=sum(temp)
qui bysort bidderid: egen w`i'=max(temp2)
drop temp temp2
}
merge m:1 bidderid using `bidderlist'
drop _merge
collapse w*, by(bidderid biddernum)
save `ltroout'

* now load the estimated wtp
insheet using Table5_mv_all.csv, clear names
rename tenderid tenderid_num
merge 1:1 tenderid_num using `agdatamro'
drop _merge
reshape long b, i(tenderid) j(biddernum)
rename b mv
replace mv=. if mv==0
merge m:1 biddernum using `bidderlist'
drop _merge
save Table5_final.dta, replace

* also add in the bids
insheet using bids.csv, clear names
rename tenderid tenderid_num
merge 1:1 tenderid_num using `agdatamro'
drop _merge
reshape long b, i(tenderid) j(biddernum)
rename b bid
replace bid=. if bid==0
keep tenderid_num biddernum bid
save Table5_final_bids.dta, replace

insheet using Table5_mv_m3.csv, clear names
rename tenderid tenderid_num
merge 1:1 tenderid_num using `agdatamro'
drop _merge
reshape long v, i(tenderid) j(biddernum)
replace biddernum=biddernum-1
rename v mv
replace mv=. if mv==0
merge m:1 biddernum using `bidderlist'
drop _merge
save Table5_final_m3.dta, replace

use  Table5_final, clear
merge 1:1 tenderid_num biddernum using Table5_final_bids.dta
tab _merge
drop _merge
merge m:1 biddernum alot_date using `defic'
drop if _merge==2
drop _merge
merge 1:1 bidderid alot_date using `cdsdef'
drop if _merge==2
drop _merge
merge m:1 bidderid using `ltroout'
drop _merge
g ltroout=.
forvalues i=1/52 {
local mind=17160+`i'*7
local maxd=17167+`i'*7
bysort bidderid: replace ltroout=w`i' if alot_date>`mind' & alot_date<=`maxd'
}
g cutoff=date("08aug2007","DMY")
g turmoil=(alot_date>=cutoff)
*save Table5_final, replace
g teuribor1w=turmoil*euribor1w
g tcdsprev=turmoil*cdsprev
g tcdslevelprev=turmoil*cdslevelprev
g teonia=turmoil*eoniaswaprate1w
drop def2 
g def2=deficiency
g tdef2=turmoil*def2
g tltroout=turmoil*ltroout
g logmv=log(mv)
g logcds=log(cdsprev)
g tlogcds=logcds*turmoil
g logltro=log(ltroout+1)
g tlogltro=turmoil*logltro
replace ltroout=ltroout/1000
replace tltroout=tltroout/1000
g logdef=log(def2+1)
g tlogdef=turmoil*logdef
g bigdef=def2>1 & def2!=.
replace bigdef=0 if def2==.
g def22= def2^2
g tdef22=turmoil*def22
g bigdef2=bigdef*def2
g tbigdef2=bigdef2*turmoil
g bigdef22=bigdef2^2
g tbigdef22=bigdef22*turmoil
g teurepo1w=turmoil*eurepo1w
g smalldef=def2<1
replace smalldef=. if def2==.
g tsmalldef=turmoil*smalldef
g smdef2=smalldef*def2
g tsmdef2=turmoil*smdef2
* banks with missing ltro data have no outstanding LTRO loan!
replace ltroout=0 if ltroout==.
replace tltroout=turmoil*ltroout

label var euribor1w "EURIBOR"
label var teuribor1w "EURIBOR*Turmoil"
label var eoniaswaprate1w "EONIA"
label var teonia "EONIA*Turmoil"
label var eurepo1w "EUREPO"
label var teurepo1w "EUREPO * Turmoil"
label var cdsprev "RCDS"
label var tcdsprev "RCDS * Turmoil"
label var ltroout "LTROOut"
label var tltroout "LTROOut * Turmoil"
label var def2 "Deficiency"
label var tdef2 "Deficiency * Turmoil"
label var smdef2 "Small Deficiency (less than 1)"
label var tsmdef2 "Small Deficiency * Turmoil"

save Table5_final2.dta, replace
*/
cd d:/ECB2007
use Table5_final2.dta,clear

su mv euribor1w turmoil teuribor1w cdsprev tcdsprev def2 tdef2 smdef2 tsmdef2 ltroout tltroout if mv!=. & cdsprev!=. & def2!=. & ltroout!=.
xtreg mv euribor1w turmoil teuribor1w cdsprev tcdsprev def2 tdef2 ltroout tltroout, i(biddernum) fe

* main regressions without clustering:
xtreg mv euribor1w turmoil teuribor1w cdsprev tcdsprev def2 tdef2 smdef2 tsmdef2 ltroout tltroout, i(biddernum) fe
est2vec table_t5, e(r2) replace vars(eoniaswaprate1w teonia euribor1w teuribor1w eurepo1w teurepo1w turmoil cdsprev tcdsprev def2 tdef2 smdef2 tsmdef2 ltroout tltroout) name(Base)
xtreg mv eurepo1w turmoil teurepo1w cdsprev tcdsprev def2 tdef2 smdef2 tsmdef2 ltroout tltroout, i(biddernum) fe
est2vec table4, addto(table_t5) name(S2) nokeep
xtreg mv eoniaswaprate1w turmoil teonia cdsprev tcdsprev def2 tdef2 smdef2 tsmdef2 ltroout tltroout, i(biddernum) fe
est2vec table4, addto(table_t5) name(S3) nokeep
*long regressions:
xtreg mv euribor1w turmoil teuribor1w cdsprev tcdsprev, i(biddernum) fe
est2vec table4, addto(table_t5) name(L1) nokeep
xtreg mv euribor1w turmoil teuribor1w def2 tdef2 smdef2 tsmdef2, i(biddernum) fe
est2vec table4, addto(table_t5) name(L2) nokeep
xtreg mv euribor1w turmoil teuribor1w ltroout tltroout, i(biddernum) fe
est2vec table4, addto(table_t5) name(L3) nokeep

* regressions with clustering at bank level for robustness:
xtreg mv eoniaswaprate1w turmoil teonia cdsprev tcdsprev def2 tdef2 smdef2 tsmdef2 ltroout tltroout, cluster(biddernum) i(biddernum) fe
xtreg mv euribor1w turmoil teuribor1w cdsprev tcdsprev def2 tdef2 smdef2 tsmdef2 ltroout tltroout, cluster(biddernum) i(biddernum) fe 
xtreg mv eurepo1w turmoil teurepo1w cdsprev tcdsprev def2 tdef2 smdef2 tsmdef2 ltroout tltroout, cluster(biddernum) i(biddernum) fe
xtreg mv eoniaswaprate1w turmoil teuribor1w cdsprev tcdsprev, cluster(biddernum) i(biddernum) fe 
xtreg mv eoniaswaprate1w turmoil teuribor1w def2 tdef2 smdef2 tsmdef2, cluster(biddernum) i(biddernum) fe
xtreg mv eoniaswaprate1w turmoil teuribor1w ltroout tltroout, cluster(biddernum) i(biddernum) fe

est2tex table_t5, replace preserve path(d:/ECB2007) digits(2) flexible(2) leadzero fancy mark(stars) label collabels(S1 S2 S3 L1 L2 L3)

* just playing around with mv normalized by eonia, and alternative specification of the non-linearity in deficiency around 1
g mvnorm=mv-eoniaswaprate1w
g defbig=def2 if def2>1 & def2!=.
replace defbig=0 if def2<1
g defsmall=1-def2 if def2<1 & def2!=.
replace defsmall=0 if def2>1 & def2!=.
g tdefbig=turmoil*defbig
g tdefsmall=turmoil*defsmall

xtreg mvnorm turmoil cdsprev tcdsprev defsmall tdefsmall defbig tdefbig ltroout tltroout, i(biddernum) fe

* dispersion of bids and values within auction
cd d:/ECB2007
use Table5_final2.dta,clear
collapse (sd) mv bid, by(tenderid_num)
sort tenderid_num
g auc=_n
twoway (line mv auc, lwidth(medium)) (line bid auc, lwidth(medium))
graph export "D:\ECB2007\dispersion.eps", as(eps) preview(off) replace

* principal component analysis
insheet using Table5_mv_all.csv, clear names
rename tenderid tenderid_num
mvdecode b*, mv(0)
foreach var of varlist b* {
qui su `var'
local obs=r(N)
if `obs'<=49 {
	drop `var'
	}
	else {
	local bidders=`bidders'+1
	}
}
di `bidders'
pca b*
pca b*, factors(7)

* now pca pre and post:
g aucid=_n
pca b* if aucid<=32, factors(5)
pca b* if aucid>32, factors(5)

insheet using bids.csv, clear names
rename tenderid tenderid_num
mvdecode b*, mv(0)
foreach var of varlist b* {
qui su `var'
local obs=r(N)
if `obs'<=49 {
	drop `var'
	}
	else {
	local bidders=`bidders'+1
	}
}
di `bidders'
pca b*
pca b*, factors(7)
* now pca pre and post:
g aucid=_n
pca b* if aucid<=32, factors(5)
pca b* if aucid>32, factors(5)


